#ifndef lint
static char yysccsid[] = "@(#)yaccpar	1.8 (Berkeley) 01/20/90";
#endif
#define YYBYACC 1
#line 5 "pepsy-yacc.y"
#ifndef	lint
static char *rcsid = "$Header: /xtel/isode/isode/pepsy/RCS/yacc.y.gnrc,v 9.0 1992/06/16 12:24:03 isode Rel $";
#endif

/* 
 * $Header: /xtel/isode/isode/pepsy/RCS/yacc.y.gnrc,v 9.0 1992/06/16 12:24:03 isode Rel $
 *
 *
 * $Log: yacc.y.gnrc,v $
 * Revision 9.0  1992/06/16  12:24:03  isode
 * Release 8.0
 *
 */

/*
 *				  NOTICE
 *
 *    Acquisition, use, and distribution of this module and related
 *    materials are subject to the restrictions of a license agreement.
 *    Consult the Preface in the User's Manual for the full terms of
 *    this agreement.
 *
 */


#include <stdio.h>
#include <ctype.h>
#include "pepsydefs.h"

#define	YYSTYPE	YYSTKTYPE


#define	YYDEBUG	1

extern int pepydebug;
extern int doexternals;

int	tagcontrol = TAG_UNKNOWN;
static int	tagdefault;
static int	listtype;
static OID	modid;

static int	yyporting = 0;

typedef struct ypa {
    char   *ya_text;
    int	    ya_lineno;
}		ypa, *YA;
#define	NULLYA	((YA) 0)
extern double pow ();

/* encoding/decoding/printing/freeing functions */
static	char	*efn, *dfn, *pfn, *ffn;

/*
 * clear the ?fn variables for the next coding functions
 */
clrfn()
{
    if (efn) {
	efn = NULLCP;
    }
    if (dfn) {
	dfn = NULLCP;
    }
    if (pfn) {
	pfn = NULLCP;
    }
    if (ffn) {
	ffn = NULLCP;
    }
}


static YA  new_action (text, lineno)
char   *text;
int	lineno;
{
    register YA	    ya;

    if ((ya = (YA) calloc (1, sizeof *ya)) == NULLYA)
	yyerror ("out of memory");

    ya -> ya_text = text;
    ya -> ya_lineno = lineno;

    return ya;
}
#define	free_action(ya)	(void) free ((char *) (ya))

typedef struct	{
    char *ys_structname;
    char *ys_ptrname;
} ysa, *YS;
#define NULLYS ((YS) 0)

static YS new_ys (str)
char	*str;
{
    register YS	ys;
    register char *p, *q;
    char c;

    if((ys = (YS) malloc (sizeof *ys)) == NULLYS)
	yyerror ("out of memory");
    q = str;
    while (isspace (*q)) q++;
    for (p = q; isalnum(*p) || *p == '_'; p++)
	continue;
    if (*p != '\0') {
	c = *p;
	*p = '\0';
	ys -> ys_structname = new_string (q);
	*p = c;
    }
    else {
	ys -> ys_structname = new_string (q);
	ys -> ys_ptrname = NULLCP;
	free (str);
	return ys;
    }
    for (q = p; *q != '$'; q++)
	if (! *q) {
	    free (str);
	    ys -> ys_ptrname = NULLCP;
	    return ys;
	}
    q++;
    while (isspace (*q)) q++;
    for (p = q; isalnum(*p) || *p == '_'; p++)
	continue;
    *p = '\0';
    ys -> ys_ptrname = new_string (q);
    free (str);
    return ys;
}
#define	free_ys(ys) (void) free ((char *) (ys))

static int  final_actions = 0;
static int  start_actions = 0;

char	*
hex2bin (s, pi)
register char   *s;
int	*pi;
{
    register char *d;
    char	*start;
    register int    c,
		    i;


    if ((d = malloc((unsigned)strlen(s)/2 + 2)) == NULLCP)
	yyerror ("out of memory");
    start = d;
    for (i = 0; *s; i++) {
	if ((c = *s++) >= 'a' && c <= 'f')
	    c -= 'a' - 0x0a;
	else
	    if (c >= 'A' && c <= 'F')
		c -= 'A' - 0x0a;
	    else
		if (c >= '0' && c <= '9')
		    c -= '0';
		else
		    c = 0;

	if (i & 1)
	    *d++ |= c & 0xf;
	else
	    *d = (c & 0xf) << 4;
    }

    *pi = i;	/* We use number semi-octets ! */
    return start;
}

char	*
bit2bin (s, pi)
register char   *s;
int	*pi;
{
    register char *d;
    char	*start;
    register int    c,
		    shft,
		    i;


    if ((d = malloc((unsigned)strlen(s)/8 + 2)) == NULLCP)
	yyerror ("out of memory");
    start = d;
    *d = 0;
    for (i = 0; *s; i++) {
	if ((c = *s++) == '1')
	    c = 1;
	else if (c == '0')
	    c = 0;
	else
	    break;	/* ?? */

	shft = 7 - i % 8;	/* shift to get to its bit */
	*d |= c << shft;
	if (shft == 0)	/* last bit in this octet so goto next octet */
	    *++d = 0;	/* initialise it to zero */
    }

    *pi = i;
    return start;
}

bin2hex (s, d, len)
register    u_char *s;
register char  *d;
int     len;
{
    register int    i,
		    g;

    for (i = 0; i < len; i++) {
	g = s[i >> 1];
	if ((i & 1) == 0)
	    g >>= 4;
	g &= 0xf;

	if (g < 0x0a)
	    *d++ = g + '0';
	else
	    *d++ = g + 'a' - 0x0a;
    }

    *d = NULL;

    return len;
}

int
hex2int(s)
register char	*s;
{
    register int	sum = 0;
    register int		i;

    while (*s) {
	if (!isxdigit(*s))
	    break;
	if (isdigit(*s))
	    i = *s - '0';
	else
	    i = tolower(*s) - 'a' + 10;
	sum = (sum << 4) + i;
	s++;
    }

    return (sum);
}

int
bit2int(s)
register char	*s;
{
    register int	sum = 0;

    while (*s) {
	if (*s != '0' && *s != '1')
	    break;
	if (*s == '1')
	    sum <<= 1;
	else
	    sum = (sum << 1) + 1;
	s++;
    }
    return (sum);
}

#line 285 "pepsy-yacc.y"
typedef union	{
    int	    yy_number;
    char   *yy_string;
    YP	    yy_type;
    YV	    yy_value;
    YT	    yy_tag;
    YA	    yy_action;
    OID	    yy_oid;
    YS	    yy_sctrl;
    double  yy_real;
    YFN     yy_yfn;
    YAL     yy_yal;
} YYSTYPE;
#line 296 "y.tab.c"
#define ABSENT 257
#define ACTION 258
#define ANY 259
#define APPLICATION 260
#define BAR 261
#define BGIN 262
#define BIT 263
#define BITSTRING 264
#define BOOLEAN 265
#define BSTRING 266
#define BY 267
#define CCE 268
#define CHOICE 269
#define COMMA 270
#define COMPONENT 271
#define COMPONENTS 272
#define COMPONENTSOF 273
#define CONTROL 274
#define DEC_FN 275
#define DECODER 276
#define DEFAULT 277
#define DEFINED 278
#define DEFINITIONS 279
#define DOT 280
#define DOTDOT 281
#define DOTDOTDOT 282
#define ENC_FN 283
#define ENCODER 284
#define ENCRYPTED 285
#define END 286
#define ENUMERATED 287
#define EXPORTS 288
#define EXPLICIT 289
#define L_FALSE 290
#define FRE_FN 291
#define FROM 292
#define HSTRING 293
#define ID 294
#define IDENTIFIER 295
#define IMPLICIT 296
#define IMPORTS 297
#define INCLUDES 298
#define INTEGER 299
#define LANGLE 300
#define LBRACE 301
#define LBRACKET 302
#define LITNUMBER 303
#define LITSTRING 304
#define LPAREN 305
#define MIN 306
#define MINUS 307
#define MAX 308
#define NAME 309
#define NIL 310
#define OBJECT 311
#define OCTET 312
#define OCTETSTRING 313
#define OF 314
#define OPTIONAL 315
#define PARAMETERTYPE 316
#define PLUS 317
#define PREFIXES 318
#define PRESENT 319
#define PRINTER 320
#define PRIVATE 321
#define PRT_FN 322
#define RBRACE 323
#define RBRACKET 324
#define REAL 325
#define RPAREN 326
#define STAR 327
#define SECTIONS 328
#define SEMICOLON 329
#define SEQUENCE 330
#define SEQUENCEOF 331
#define SET 332
#define SETOF 333
#define SIZE 334
#define STRING 335
#define TAGS 336
#define L_TRUE 337
#define UNIVERSAL 338
#define VALA 339
#define VALB 340
#define VALI 341
#define VALS 342
#define VALP 343
#define VALO 344
#define VALOID 345
#define VALR 346
#define VALT 347
#define VALTYPE 348
#define VALQ 349
#define VALX 350
#define VLENGTH 351
#define WITH 352
#define SCTRL 353
#define PLUSINFINITY 354
#define MINUSINFINITY 355
#define EACTION 356
#define DACTION 357
#define PACTION 358
#define ECHOICE 359
#define DCHOICE 360
#define PCHOICE 361
#define YYERRCODE 256
short yylhs[] = {                                        -1,
   57,   59,    0,   55,   55,   55,   14,   62,   62,   56,
   56,   58,   58,   60,   67,   63,   63,   66,   66,   69,
   64,   64,   68,   68,   70,   70,   71,   16,   16,   16,
   16,   16,   16,   15,   15,   65,   65,   72,   72,   72,
   72,   72,    8,    8,   73,   73,   45,   45,   45,   45,
   46,   46,   46,   46,   74,   17,   17,   17,    6,    6,
    5,    5,   32,   32,   18,   18,   18,   18,   18,   18,
   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,
   18,   18,   18,   18,   18,   18,   43,   43,   19,   19,
   20,   20,   20,   20,   20,   20,   20,   20,    1,    1,
   11,   11,   12,   12,   10,   10,    9,    9,   21,   21,
   21,   22,   22,   22,   22,   13,   13,   23,   44,   44,
   81,   81,   81,   81,   80,   80,    7,    7,   33,   33,
   34,   35,   35,   24,   24,   30,   30,   25,   25,   26,
   26,   26,   26,   26,   26,   27,   27,   28,   29,   29,
   47,   48,   48,   48,   48,   75,   36,   36,   37,   37,
   37,   37,   37,   37,   37,   37,   37,   37,   37,   37,
    2,    2,    4,    4,    3,   38,   38,   38,   39,   39,
   40,   40,   41,   41,   42,   61,   77,   77,   76,   76,
   78,   78,   79,   79,   82,   82,   50,   49,   49,   51,
   51,   52,   52,   53,   31,   31,   31,   83,   85,   85,
   86,   86,   87,   87,   87,   87,   88,   88,   89,   90,
   93,   93,   94,   94,   95,   95,   96,   96,   84,   91,
   92,   92,   97,   98,   98,   99,  100,  101,  101,  102,
  102,  103,  103,  103,  104,  105,  105,   54,   54,
};
short yylen[] = {                                         2,
    0,    0,   12,    2,    2,    1,    2,    1,    1,    1,
    1,    4,    1,    3,    0,    4,    1,    1,    1,    0,
    4,    1,    1,    1,    2,    1,    3,    3,    1,    4,
    2,    4,    2,    1,    1,    3,    1,    2,    2,    2,
    4,    1,    1,    1,    1,    1,    2,    2,    2,    1,
    2,    2,    2,    1,    5,    3,    3,    3,    1,    1,
    1,    1,    1,    1,    2,    3,    5,    3,    2,    1,
    3,    6,    7,    3,    6,    7,    4,    4,    3,    9,
    3,    2,    3,    3,    2,    2,    3,    1,    3,    5,
    1,    1,    1,    2,    1,    1,    1,    1,    1,    4,
    1,    1,    1,    1,    1,    1,    1,    1,    2,    1,
    1,    1,    2,    1,    1,    1,    1,    1,    1,    0,
    1,    1,    1,    1,    1,    2,    1,    1,    1,    3,
    4,    1,    1,    1,    1,    1,    1,    1,    4,    1,
    3,    3,    4,    1,    2,    2,    1,    2,    1,    4,
    4,    1,    1,    1,    1,    4,    1,    1,    1,    1,
    1,    1,    1,    4,    1,    1,    3,    2,    2,    1,
    1,    1,    1,    1,    7,    1,    1,    3,    3,    1,
    1,    1,    1,    3,    1,    0,    2,    1,    1,    2,
    1,    2,    1,    2,    1,    2,    3,    1,    2,    1,
    1,    1,    1,    4,    2,    7,    7,    4,    1,    1,
    3,    1,    1,    1,    1,    1,    1,    1,    2,    3,
    1,    2,    1,    2,    1,    1,    1,    1,    2,    2,
    3,    3,    1,    1,    1,    3,    5,    1,    3,    2,
    1,    1,    1,    1,    1,    1,    1,    1,    1,
};
short yydefred[] = {                                      0,
    0,    0,    0,    0,    8,    9,    7,    0,    0,  202,
    0,  203,    0,  198,  200,  201,    0,    0,    0,    6,
    0,    0,  197,  199,    4,    5,    1,  178,  177,    0,
    0,  204,   10,    0,   11,    0,    2,   13,   43,   44,
    0,    0,    0,    0,   12,   15,    0,   17,    0,    0,
    0,   20,   22,  186,   34,    0,   35,    0,   29,    0,
   19,    0,    3,    0,   37,    0,   31,   33,    0,   16,
    0,   24,    0,    0,   26,    0,    0,    0,    0,   42,
    0,    0,    0,   28,    0,   21,   25,   39,   38,   40,
    0,    0,    0,   36,   45,   46,   30,   32,   27,    0,
   61,    0,   62,    0,    0,  189,    0,    0,    0,    0,
    0,    0,    0,    0,   70,    0,    0,  188,    0,    0,
    0,  191,    0,  193,    0,    0,    0,    0,    0,  186,
    0,    0,    0,    0,   41,  186,    0,  190,  105,   65,
  106,  248,    0,  249,    0,  107,    0,  108,    0,   91,
   92,   93,  112,    0,   95,   96,   97,  114,    0,    0,
   98,  115,  118,    0,  153,  154,  152,    0,  155,    0,
    0,  187,  116,   86,  117,    0,  192,    0,    0,    0,
  194,    0,    0,  103,   82,  104,    0,    0,  205,  122,
  121,  124,  123,  186,    0,  125,  186,  186,    0,   50,
  110,    0,    0,  111,   69,    0,    0,    0,    0,   63,
    0,   64,    0,    0,  113,   94,  127,   89,  128,    0,
   66,   88,  132,    0,  133,    0,  101,   84,  102,   83,
  229,   71,    0,    0,    0,   74,    0,    0,  162,  160,
  163,    0,    0,  161,  165,    0,    0,  159,  173,  174,
  170,  171,  172,    0,  156,  157,  158,    0,    0,  226,
    0,    0,  217,    0,  209,  210,  214,  215,  216,  218,
    0,    0,    0,  126,    0,    0,    0,    0,   47,   48,
   49,    0,  109,   68,    0,    0,    0,  100,   59,  186,
   60,    0,    0,  129,    0,    0,  151,  186,  186,  186,
  186,    0,    0,    0,  185,    0,    0,  183,  182,  168,
  169,  230,    0,    0,    0,    0,  212,    0,    0,  222,
    0,    0,  186,  186,    0,   54,    0,    0,   67,   90,
   87,    0,    0,    0,    0,    0,    0,    0,    0,  167,
    0,  233,  231,    0,  232,  234,  235,    0,  208,    0,
  228,  227,  220,  223,    0,    0,  186,   51,   52,   53,
    0,  130,    0,  195,    0,    0,    0,    0,  138,    0,
  144,  135,    0,    0,    0,    0,  137,    0,    0,  164,
    0,  184,  247,    0,    0,  246,  244,  245,    0,    0,
  241,  242,  243,  211,  224,    0,    0,    0,  131,  196,
    0,  145,   73,  186,    0,    0,    0,    0,   76,    0,
  179,    0,    0,  240,  236,    0,    0,  149,    0,    0,
    0,  141,    0,   54,    0,    0,  239,  186,   80,  139,
  143,  175,  237,    0,  150,
};
short yydgoto[] = {                                       2,
  125,  251,  252,  253,  102,  290,  218,   41,  147,  140,
  228,  185,  174,    3,   59,   71,  254,  127,  128,  160,
  203,  161,  162,  367,  368,  369,  370,  371,  419,  376,
  129,  211,  293,  294,  224,  262,  256,  257,  337,  306,
  307,  308,  221,  194,  199,  325,  130,  168,   13,    5,
   14,   15,   16,  143,   19,   34,   31,   37,   42,   47,
  200,    7,   49,   54,   66,   62,   50,   73,   64,   74,
   75,   81,   94,   95,   96,  131,  132,  133,  134,  195,
  196,  373,  189,  263,  264,  318,  265,  266,  267,  268,
  269,  270,  271,  353,  272,  354,  343,  345,  346,  347,
  389,  390,  391,  392,  393,
};
short yysindex[] = {                                   -271,
 -274,    0, -228,  -55,    0,    0,    0,  -98, -157,    0,
 -158,    0,  -65,    0,    0,    0, -195, -181, -111,    0,
 -117,  -43,    0,    0,    0,    0,    0,    0,    0, -136,
  -58,    0,    0,  -92,    0, -143,    0,    0,    0,    0,
 -143,  -80, -143,  -48,    0,    0,  -79,    0,  -52,  -12,
  -58,    0,    0,    0,    0, -108,    0, -108,    0,  -38,
    0,  -83,    0,  -12,    0, -116,    0,    0,   13,    0,
 -254,    0,  -73,  -12,    0, -143, -143, -143, -143,    0,
   16, -108, -108,    0, -271,    0,    0,    0,    0,    0,
 -143,  -66, 3513,    0,    0,    0,    0,    0,    0, -143,
    0,   -9,    0,  -14,  -68,    0,  -59,  -63, 3513,  -54,
 -122,  -54, -257,    4,    0,   19,  -24,    0,  -33,   64,
 -150,    0,  -81,    0,  -13, -248, -247, -247, -247,    0,
 -292,  -56,  -63,  -63,    0,    0,   70,    0,    0,    0,
    0,    0,   -7,    0,   39,    0,   50,    0,   65,    0,
    0,    0,    0,   12,    0,    0,    0,    0,   14,   26,
    0,    0,    0,   72,    0,    0,    0,   18,    0, 3513,
   34,    0,    0,    0,    0,  -13,    0,   39, -308,   57,
    0, -308,   69,    0,    0,    0, 3271, 2986,    0,    0,
    0,    0,    0,    0, -247,    0,    0,    0, 2235,    0,
    0,   35,   72,    0,    0,   -7,   -7, 2535,   76,    0,
  117,    0,   83,  259,    0,    0,    0,    0,    0,   83,
    0,    0,    0,   75,    0,   39,    0,    0,    0,    0,
    0,    0,   95,    0,  -63,    0,   96,  -63,    0,    0,
    0,  -71, 3328,    0,    0, 3100,    0,    0,    0,    0,
    0,    0,    0, 3157,    0,    0,    0,   39, 3513,    0,
 -176,    0,    0,  141,    0,    0,    0,    0,    0,    0,
  122,  106,   73,    0,   73,   73, 3513, 3513,    0,    0,
    0,   39,    0,    0,  117,  117,   39,    0,    0,    0,
    0,  102, -245,    0,   26, -238,    0,    0,    0,    0,
    0,  115,  -71,  143,    0,   88,  144,    0,    0,    0,
    0,    0,   39,   39,  124, 2986,    0,   90, 3043,    0,
   39,   39,    0,    0, -166,    0,   18,   83,    0,    0,
    0, 2310, -253, 2310, -253,  259, -210,    0,  129,    0,
 3271,    0,    0, -120,    0,    0,    0,  141,    0, 3214,
    0,    0,    0,    0, 2535, 2535,    0,    0,    0,    0,
  113,    0,  126,    0, 3403,   39,  123,  177,    0, -236,
    0,    0, 3513, 3513,  177,  127,    0, 3513,  159,    0,
  184,    0,    0,  185, -246,    0,    0,    0,  133,  188,
    0,    0,    0,    0,    0,   39,   39, 2610,    0,    0,
   39,    0,    0,    0, 3271,  117,   39,   39,    0,   39,
    0,  161, -171,    0,    0, -171, 3458,    0, -204, 2310,
  117,    0,   77,    0,  142,  149,    0,    0,    0,    0,
    0,    0,    0, 2610,    0,
};
short yyrindex[] = {                                      0,
   81,    0,    0,    0,    0,    0,    0,  198,  470,    0,
    6,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 -250,    0,    0,  212,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   80,    0,    0,    0,    0,  -29,  146,
  476,    0,    0,    0,    0,    0,    0,    0,    0,  148,
    0,    0,    0,  146,    0, -165,    0,    0,    0,    0,
    0,    0,    0,  150,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  198,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  258,    0,    0,  658, -272,    0,  181,
  358,  658,   84,    0,    0,    0,    0,    0,  658,    0,
  158,    0,  158,    0,  658,    0, 1933, 1933, 1933,    0,
  658,  658, 2385, 2385,    0,    0,    0,    0,    0,    0,
    0,    0, -259,    0,  958,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  658,
    0,    0,    0, 1058,    0,    0,    0,    0,    0,    0,
  658,    0,    0,    0,    0,  658,    0,    0,  658,    0,
    0,  658,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 2008,    0,    0,    0,    0,    0,
    0,    0, 1058,    0,    0, 2460, 2460,    0,    0,    0,
 -145,    0,    0,  358,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1158,    0,    0,    0,    0,
    0,    0,    0,  758, 2460,    0,    0, 2460,    0,    0,
    0,  458,  164,    0,    0,   22,  858,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, -244,    0,  166,    0,    0,    0,    0,    0,    0,
    0,  213, 2761,    0, 2836, 2911,    0,    0,    0,    0,
    0, 1258,    0,    0, 2685, 2685,   52,    0,    0,    0,
    0,    0,    0,    0,  658,    0,    0,    0,    0,    0,
    0,    0, 2084,  170,    0,    0,  173,    0,    0,    0,
    0,    0, -243,    0,    0,    0,    0,    0,    0,    0,
 1358, 1458,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  164, 3568,  164, 3568,  558,    0, 2160,    0,    0,
    0,    0,    0, -196,    0,    0,    0,  166,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, -231,    0,  175,    0, -180,
    0,    0,    0,    0,  176,    0,    0,    0,    0,    0,
    0,    0,    0,    0, -196,    0,    0,    0,    0,  178,
    0,    0,    0,    0,    0, 1558, 1658,    0,    0,    0,
 -162,    0,    0,    0,    0, -262, -154, 1758,    0, 1858,
    0,    0, -196,    0,    0, -196,    0,    0,    0,    0,
 -196,    0, -144,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,
};
short yygindex[] = {                                      0,
  380,    0,    0,    0,    0, -281,  207,  276,  391,    0,
    0,  -30,    0,  419,  312,  455,  -16,    0,    0, -208,
    0,  375,  377,    0,  186,   89, -372,  145,    0,    0,
    0,   29,  291,  190,  202, -174,    0,   -3,    0,    0,
    0,  189,  322,   59, -127,  125,    0,    0,    0,    0,
  519,  514,    0,  -99,    0,  486,    0,    0,    0,    0,
   -1,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  464,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  344,    0, -164,  -76,  224,  199,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  196,    0,    0,    0,    0,
 -299,    0,  165,    0,    0,
};
#define YYTABLESIZE 3901
short yytable[] = {                                       6,
   12,  186,  165,  323,  324,  295,   20,  186,  208,   12,
  383,  186,  255,  231,  186,   69,  213,  219,   12,  187,
  289,  179,    1,  182,  328,  418,    4,  190,  186,   35,
  184,  328,   38,  206,  207,  191,  225,   85,  147,  210,
  405,  186,   48,  192,  180,  147,  183,   53,   61,   35,
    8,  374,   65,  378,  201,  225,  188,  202,  188,  379,
  186,  435,   72,  166,   80,  428,  273,  186,  305,  275,
  276,  310,  386,  186,  193,  186,  126,  329,  406,  311,
  167,  213,  219,  147,  331,  383,  186,  186,  186,  140,
  103,  147,  145,  312,  314,  315,  186,  186,  186,  186,
  186,  186,  279,  280,  281,  141,  144,  146,  148,  163,
  148,  169,  380,  426,  146,  148,  427,  175,  429,  144,
   14,  144,   21,  186,  422,  142,  186,  295,  186,  163,
  163,  144,  144,  188,  357,  299,  383,  385,  301,  431,
   25,  212,  140,  186,  352,  230,   22,  386,  232,  342,
   39,  236,  146,  226,   26,  186,   27,  149,  219,   76,
  146,  384,  222,  177,  225,   40,  305,   77,  148,  229,
  332,  333,  334,  335,  186,  352,   28,  234,  142,  388,
  234,   44,  282,  178,  188,   55,  197,  198,  385,   32,
   17,  287,  358,  359,  360,  355,  356,   18,  386,   33,
   57,  222,  142,   78,  212,  212,   51,  233,  302,  291,
  237,   79,  163,  186,  186,  186,  150,  151,  152,  153,
  388,  154,  155,  156,  157,   36,  158,  159,    9,  398,
  421,   69,  181,  144,  285,  286,  144,   10,    9,   46,
  163,  309,  313,   11,   52,   70,  186,   10,  388,  101,
    9,  388,  178,   11,  186,   86,  186,   23,  136,   10,
  321,  322,  317,  137,  186,   29,  138,  150,  151,  152,
  153,  142,  154,  155,  156,  157,  420,  158,  159,  186,
  139,   55,  177,  291,  291,  153,  146,  154,  326,  142,
  186,  177,  158,  219,   56,  177,   57,  177,  186,  177,
  434,  338,  177,  170,   58,  177,   55,  177,  177,   92,
  172,    9,  173,  171,  177,  366,   43,  366,   45,   82,
  223,   57,  104,  225,   93,  184,   29,   55,  177,   83,
  372,  291,  377,  291,  163,   55,  209,   55,  396,  397,
  210,  177,  387,  188,  177,   55,  317,  177,  401,  177,
  213,   88,   89,   90,   91,  186,  407,  408,  214,  186,
   55,  410,  215,  186,  216,  186,  100,   67,  217,   68,
  235,   55,  220,  186,  186,  135,  186,  186,  227,   55,
   84,  366,  238,  387,  288,  283,  186,  186,  186,  186,
  289,  292,  186,   97,   98,  298,  300,  186,  297,  186,
  401,  316,  319,  366,  424,  320,  327,  186,  336,  186,
  340,  387,  339,  341,  387,  349,  186,  366,  186,  291,
  186,  186,  186,  186,  344,  186,  186,  186,  279,  280,
  281,  381,  186,  186,  186,  358,  359,  360,  399,  400,
  186,  186,  186,  186,  186,  403,  404,  186,  186,  409,
  186,  186,  411,  412,  413,  415,  186,  416,  186,  186,
  186,  186,  186,  425,  432,  186,  186,  186,  186,  186,
  186,  433,  186,  186,  186,  186,   18,  186,   23,  186,
  186,  186,  186,  186,  186,  186,  186,  186,  186,  186,
  186,  186,  161,  221,  186,  181,  186,  134,  136,  176,
  238,  330,  164,   99,   60,  186,  205,  204,  430,  402,
  296,  186,  186,  186,  186,  186,   99,  362,   99,  375,
   99,   99,   99,   99,  284,   99,   99,   99,  361,  382,
  423,   24,   99,   99,   99,   30,   63,   87,  274,  348,
   99,   99,   99,   99,   99,  395,  394,   99,   99,  414,
   99,   99,    0,    0,    0,    0,   99,    0,   99,   99,
   99,   99,   99,    0,    0,    0,   99,   99,   99,   99,
   99,    0,   99,    0,    0,    0,    0,   99,    0,   99,
   99,    0,   99,   99,   99,   99,    0,   99,   99,   99,
   99,    0,    0,    0,   99,    0,   99,  150,  151,  152,
  153,    0,  154,  155,  156,  157,    0,  158,  159,    0,
    0,   99,   99,   99,   99,   99,  186,    0,  186,    0,
  186,  186,  186,  186,    0,  186,  186,  186,    0,    0,
    0,    0,  186,  186,  186,    0,    0,    0,    0,    0,
  186,  186,  186,  186,  186,    0,    0,  186,  186,    0,
  186,  186,    0,    0,    0,    0,  186,    0,  186,  186,
  186,  186,  186,    0,    0,    0,  186,  186,  186,  186,
  186,    0,  186,    0,    0,    0,    0,  186,    0,  186,
  186,    0,  186,  186,  186,  186,    0,  186,  186,  186,
  186,    0,    0,    0,  186,    0,    0,    0,    0,    0,
  186,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  186,  186,  186,  186,  186,  186,    0,  176,    0,
  186,  186,  186,  186,    0,    0,  186,  176,    0,    0,
    0,  176,  186,  176,    0,    0,    0,    0,  176,    0,
  186,  176,  186,  176,  186,    0,    0,  186,  186,    0,
  186,  176,    0,    0,    0,    0,  186,  176,  186,  186,
  186,  186,  186,  176,    0,    0,  176,  186,  186,  186,
  186,    0,  176,    0,    0,    0,    0,  176,  176,  186,
  176,    0,  186,  176,  186,  176,    0,  186,  186,  186,
  186,    0,  176,  176,  186,  176,    0,    0,    0,    0,
  186,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  186,  186,  186,  186,  186,  186,    0,  178,    0,
  186,  186,  186,  186,    0,    0,  186,  178,    0,    0,
    0,  178,  186,  178,    0,    0,    0,    0,  178,    0,
  186,  178,  186,  178,  186,    0,    0,  186,  186,    0,
  186,  178,    0,    0,    0,    0,  186,  178,  186,  186,
  186,  186,  186,    0,    0,    0,  178,  186,  186,  186,
  186,    0,    0,    0,    0,    0,    0,  178,    0,  186,
  178,    0,  186,  178,  186,  178,    0,  186,  186,  186,
  186,    0,    0,    0,  186,    0,    0,    0,    0,    0,
  186,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  186,  186,  186,  186,  186,  186,    0,  186,    0,
  186,  186,  186,  186,    0,  186,  186,  186,    0,    0,
    0,    0,  186,  186,  186,    0,    0,    0,    0,    0,
  186,  186,  186,  186,  186,    0,    0,  186,  186,    0,
  186,  186,    0,    0,    0,    0,  186,    0,  186,  186,
  186,  186,  186,    0,    0,    0,  186,  186,  186,  186,
  186,    0,  186,    0,    0,    0,    0,  186,    0,  186,
  186,    0,  186,  186,  186,  186,    0,  186,  186,  186,
  186,    0,    0,    0,  186,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  186,  186,  186,  186,  186,  104,    0,  104,    0,
  104,  104,  104,  104,    0,  104,  104,  104,    0,    0,
    0,    0,  104,  104,  104,    0,    0,    0,    0,    0,
  104,  104,  104,  104,  104,    0,    0,  104,  104,    0,
  104,  104,    0,    0,    0,    0,  104,    0,   64,  104,
  104,  104,  104,    0,    0,    0,  104,  104,  104,  104,
  104,    0,  104,    0,    0,    0,    0,  104,    0,  104,
  104,    0,  104,  104,  104,  104,    0,  104,  104,  104,
  104,    0,    0,    0,  104,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  104,  104,  104,  104,  104,   70,    0,  166,    0,
   70,   70,   70,   70,    0,    0,   70,  166,    0,    0,
    0,  166,   70,  166,    0,    0,    0,    0,  166,    0,
   70,  166,   70,  166,   70,    0,    0,   70,   70,    0,
   70,   70,    0,    0,    0,    0,   70,  166,   70,   70,
   70,   70,   70,    0,    0,    0,   70,   70,   70,   70,
   70,    0,    0,    0,    0,    0,    0,  166,    0,   70,
  166,    0,   70,  166,   70,  166,    0,   70,   70,   70,
   70,    0,    0,    0,   70,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   70,   70,   70,   70,   70,   85,    0,   85,    0,
   85,   85,   85,   85,    0,   85,   85,   85,    0,    0,
    0,    0,   85,   85,   85,    0,    0,    0,    0,    0,
   85,   85,   85,   85,   85,    0,    0,   85,   85,    0,
   85,   85,    0,    0,    0,    0,   85,    0,   85,   85,
   85,   85,    0,    0,    0,    0,   85,   85,   85,   85,
   85,    0,   85,    0,    0,    0,    0,   85,    0,   85,
   85,    0,   85,   85,   85,   85,    0,   85,   85,   85,
   85,    0,    0,    0,   85,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   85,   85,   85,   85,   85,  186,    0,  186,    0,
  186,  186,  186,  186,    0,  186,  186,  186,    0,    0,
    0,    0,  186,  186,  186,    0,    0,    0,    0,    0,
  186,  186,  186,  186,  186,    0,    0,  186,  186,    0,
  186,  186,    0,    0,    0,    0,  186,    0,    0,  186,
  186,  186,  186,    0,    0,    0,  186,  186,  186,  186,
  186,    0,  186,    0,    0,    0,    0,  186,    0,  186,
  186,    0,  186,  186,  186,  186,    0,  186,  186,  186,
  186,    0,    0,    0,  186,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  186,  186,  186,  186,  186,   81,    0,   81,    0,
   81,   81,   81,   81,    0,   81,   81,   81,    0,    0,
    0,    0,   81,   81,   81,    0,    0,    0,    0,    0,
   81,   81,   81,   81,   81,    0,    0,   81,   81,    0,
   81,   81,    0,    0,    0,    0,   81,    0,   81,   81,
   81,   81,    0,    0,    0,    0,   81,   81,   81,   81,
   81,    0,   81,    0,    0,    0,    0,   81,    0,   81,
   81,    0,   81,   81,   81,   81,    0,   81,   81,   81,
   81,    0,    0,    0,   81,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   81,   81,   81,   81,   81,   79,    0,   79,    0,
   79,   79,   79,   79,    0,   79,   79,   79,    0,    0,
    0,    0,   79,   79,   79,    0,    0,    0,    0,    0,
   79,   79,   79,   79,   79,    0,    0,   79,   79,    0,
   79,   79,    0,    0,    0,    0,   79,    0,   79,   79,
   79,   79,    0,    0,    0,    0,   79,   79,   79,   79,
   79,    0,   79,    0,    0,    0,    0,   79,    0,   79,
   79,    0,   79,   79,   79,   79,    0,   79,   79,   79,
   79,    0,    0,    0,   79,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   79,   79,   79,   79,   79,   78,    0,   78,    0,
   78,   78,   78,   78,    0,   78,   78,   78,    0,    0,
    0,    0,   78,   78,   78,    0,    0,    0,    0,    0,
   78,   78,   78,   78,   78,    0,    0,   78,   78,    0,
   78,   78,    0,    0,    0,    0,   78,    0,   78,   78,
   78,   78,    0,    0,    0,    0,   78,   78,   78,   78,
   78,    0,   78,    0,    0,    0,    0,   78,    0,   78,
   78,    0,   78,   78,   78,   78,    0,   78,   78,   78,
   78,    0,    0,    0,   78,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   78,   78,   78,   78,   78,   77,    0,   77,    0,
   77,   77,   77,   77,    0,   77,   77,   77,    0,    0,
    0,    0,   77,   77,   77,    0,    0,    0,    0,    0,
   77,   77,   77,   77,   77,    0,    0,   77,   77,    0,
   77,   77,    0,    0,    0,    0,   77,    0,   77,   77,
   77,   77,    0,    0,    0,    0,   77,   77,   77,   77,
   77,    0,   77,    0,    0,    0,    0,   77,    0,   77,
   77,    0,   77,   77,   77,   77,    0,   77,   77,   77,
   77,    0,    0,    0,   77,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   77,   77,   77,   77,   77,   72,    0,   72,    0,
   72,   72,   72,   72,    0,   72,   72,   72,    0,    0,
    0,    0,   72,   72,   72,    0,    0,    0,    0,    0,
   72,   72,   72,   72,   72,    0,    0,   72,   72,    0,
   72,   72,    0,    0,    0,    0,   72,    0,   72,   72,
   72,   72,    0,    0,    0,    0,   72,   72,   72,   72,
   72,    0,   72,    0,    0,    0,    0,   72,    0,   72,
   72,    0,   72,   72,   72,   72,    0,   72,   72,   72,
   72,    0,    0,    0,   72,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   72,   72,   72,   72,   72,   75,    0,   75,    0,
   75,   75,   75,   75,    0,   75,   75,   75,    0,    0,
    0,    0,   75,   75,   75,    0,    0,    0,    0,    0,
   75,   75,   75,   75,   75,    0,    0,   75,   75,    0,
   75,   75,    0,    0,    0,    0,   75,    0,   75,   75,
   75,   75,    0,    0,    0,    0,   75,   75,   75,   75,
   75,    0,   75,    0,    0,    0,    0,   75,    0,   75,
   75,    0,   75,   75,   75,   75,    0,   75,   75,   75,
   75,    0,    0,    0,   75,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   75,   75,   75,   75,   75,  207,    0,  207,    0,
  207,  207,  207,  207,    0,  207,  207,  207,    0,    0,
    0,    0,  207,  207,  207,    0,    0,    0,    0,    0,
  207,  207,  207,  207,  207,    0,    0,  207,  207,    0,
  207,  207,    0,    0,    0,    0,  207,    0,  207,  207,
  207,  207,    0,    0,    0,    0,  207,  207,  207,  207,
  207,    0,  207,    0,    0,    0,    0,  207,    0,  207,
  207,    0,  207,  207,  207,  207,    0,  207,  207,  207,
  207,    0,    0,    0,  207,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  207,  207,  207,  207,  207,  206,    0,  206,    0,
  206,  206,  206,  206,    0,  206,  206,  206,    0,    0,
    0,    0,  206,  206,  206,    0,    0,    0,    0,    0,
  206,  206,  206,  206,  206,    0,    0,  206,  206,    0,
  206,  206,    0,    0,    0,    0,  206,    0,  206,  206,
  206,  206,    0,    0,    0,    0,  206,  206,  206,  206,
  206,    0,  206,    0,    0,    0,    0,  206,    0,  206,
  206,    0,  206,  206,  206,  206,    0,  206,  206,  206,
  206,  120,    0,  120,  206,  120,  120,  120,  120,    0,
  120,  120,  120,    0,    0,    0,    0,    0,  120,  120,
    0,  206,  206,  206,  206,  206,  120,  120,  120,  120,
    0,    0,  120,    0,    0,  120,  120,    0,    0,    0,
    0,  120,    0,  120,  120,  120,  120,  120,    0,    0,
    0,  120,  120,  120,  120,  120,    0,  120,    0,    0,
    0,    0,  120,    0,    0,  120,    0,  120,  120,  120,
  120,    0,  120,  120,  120,  120,  119,    0,  119,  120,
  119,  119,  119,  119,    0,  119,  119,  119,    0,    0,
    0,    0,    0,  119,  119,    0,  120,  120,  120,  120,
  120,  119,  119,  119,  119,    0,    0,  119,    0,    0,
  119,  119,    0,    0,    0,    0,  119,    0,  119,  119,
  119,  119,  119,    0,    0,    0,  119,  119,  119,  119,
  119,    0,  119,    0,    0,    0,    0,  119,    0,    0,
  119,    0,  119,  119,  119,  119,    0,  119,  119,  119,
  119,    0,  186,    0,  119,    0,  186,  186,  186,  186,
    0,    0,  186,  176,    0,    0,    0,    0,  186,    0,
    0,  119,  119,  119,  119,  119,  186,    0,  186,    0,
  186,    0,    0,  186,  186,    0,  186,  186,    0,    0,
    0,    0,  186,    0,  186,  186,  186,  186,  186,    0,
    0,    0,  186,  186,  186,  186,  186,    0,    0,    0,
    0,    0,    0,    0,    0,  186,  176,    0,  186,    0,
  186,    0,    0,  186,  186,  186,  186,    0,  118,    0,
  186,    0,  118,  118,  118,  118,  186,    0,  118,  180,
    0,    0,    0,    0,  118,    0,    0,  186,  186,  186,
  186,  186,  118,    0,  118,    0,  118,    0,    0,  118,
  118,    0,  118,  118,    0,    0,    0,    0,  118,    0,
  118,  118,  118,  118,  118,    0,    0,    0,  118,  118,
  118,  118,  118,    0,    0,    0,    0,    0,    0,    0,
    0,  118,  180,    0,  118,    0,  118,    0,    0,  118,
  118,  118,  118,  104,    0,    0,  118,  105,  106,  107,
    0,    0,  118,  108,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  118,  118,  118,  118,  118,    0,  109,
    0,  110,    0,  277,    0,    0,    0,    0,  111,    0,
  278,    0,    0,  112,    0,    0,  113,    0,    0,    0,
    0,    0,    0,  114,  115,  116,  117,  118,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  119,
    0,  120,    0,    0,  121,  122,  123,  124,  104,    0,
    0,    0,  105,  106,  107,    0,    0,    0,  108,    0,
    0,  363,  364,    0,    0,    0,    0,    0,    0,    0,
  279,  280,  281,    0,  109,    0,  110,    0,    0,    0,
    0,    0,    0,  111,    0,    0,    0,    0,  112,    0,
    0,  113,    0,    0,    0,    0,    0,    0,  365,  115,
  116,  117,  118,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  119,    0,  120,    0,    0,  121,
  122,  123,  124,  186,    0,    0,    0,  186,  186,  186,
    0,    0,    0,  186,    0,    0,    0,    0,  186,    0,
    0,    0,    0,    0,    0,  279,  280,  281,    0,  186,
    0,  186,    0,    0,    0,    0,    0,    0,  186,    0,
    0,    0,    0,  186,    0,    0,  186,    0,    0,    0,
    0,    0,    0,  186,  186,  186,  186,  186,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  186,
    0,  186,    0,    0,  186,  186,  186,  186,  186,    0,
    0,    0,  186,  186,  186,    0,    0,    0,  186,    0,
    0,    0,  186,  186,    0,    0,    0,    0,    0,    0,
  186,  186,  186,    0,  186,    0,  186,    0,    0,    0,
    0,    0,    0,  186,    0,    0,    0,    0,  186,    0,
    0,  186,    0,    0,    0,    0,    0,    0,  186,  186,
  186,  186,  186,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  186,    0,  186,    0,    0,  186,
  186,  186,  186,  104,    0,    0,    0,  105,  106,  107,
    0,    0,    0,  108,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  186,  186,  186,    0,  109,
    0,  110,    0,    0,    0,    0,    0,    0,  111,    0,
    0,    0,    0,  112,    0,    0,  113,    0,    0,    0,
    0,    0,    0,  114,  115,  116,  117,  118,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  119,
    0,  120,    0,    0,  121,  122,  123,  124,  104,    0,
    0,    0,  105,  106,  107,    0,    0,    0,  108,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  279,  280,  281,    0,  109,    0,  110,    0,    0,    0,
    0,    0,    0,  111,    0,    0,    0,    0,  112,    0,
    0,  113,    0,    0,    0,    0,    0,    0,  417,  115,
  116,  117,  118,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  119,    0,  120,    0,    0,  121,
  122,  123,  124,  186,    0,    0,    0,  186,  186,  186,
    0,    0,    0,  186,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  279,  280,  281,    0,  186,
    0,  186,    0,    0,    0,    0,    0,    0,  186,    0,
    0,    0,    0,  186,    0,    0,  186,    0,    0,    0,
    0,    0,    0,  186,  186,  186,  186,  186,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  186,
    0,  186,    0,    0,  186,  186,  186,  186,    0,   56,
    0,   56,    0,   56,   56,   56,   56,    0,   56,   56,
   56,    0,    0,    0,    0,   56,   56,   56,    0,    0,
  186,  186,  186,   56,   56,   56,   56,   56,    0,    0,
   56,   56,    0,   56,   56,    0,    0,    0,    0,   56,
    0,   56,   56,   56,   56,   56,    0,    0,    0,   56,
   56,   56,   56,   56,    0,   56,    0,    0,    0,    0,
   56,    0,   56,   56,    0,   56,   56,   56,   56,    0,
   56,   56,   56,   56,   57,    0,   57,   56,   57,   57,
   57,   57,    0,   57,   57,   57,    0,    0,    0,    0,
   57,   57,   57,    0,   56,   56,    0,    0,   57,   57,
   57,   57,   57,    0,    0,   57,   57,    0,   57,   57,
    0,    0,    0,    0,   57,    0,   57,   57,   57,   57,
   57,    0,    0,    0,   57,   57,   57,   57,   57,    0,
   57,    0,    0,    0,    0,   57,    0,   57,   57,    0,
   57,   57,   57,   57,    0,   57,   57,   57,   57,   58,
    0,   58,   57,   58,   58,   58,   58,    0,   58,   58,
   58,    0,    0,    0,    0,   58,   58,   58,    0,   57,
   57,    0,    0,   58,   58,   58,   58,   58,    0,    0,
   58,   58,    0,   58,   58,    0,    0,    0,    0,   58,
    0,   58,   58,   58,   58,   58,    0,    0,    0,   58,
   58,   58,   58,   58,    0,   58,    0,    0,    0,    0,
   58,    0,   58,   58,    0,   58,   58,   58,   58,    0,
   58,   58,   58,   58,  104,    0,    0,   58,  105,  106,
  107,  239,    0,    0,  108,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   58,   58,    0,    0,    0,    0,
  109,    0,  110,    0,    0,  240,    0,  258,  241,  242,
    0,    0,    0,  259,  112,    0,  243,  113,  244,  245,
    0,  260,    0,    0,  246,  247,  116,  117,  118,    0,
    0,  104,    0,    0,    0,  105,  106,  107,  239,    0,
  119,  108,  120,    0,    0,  121,  122,  123,  124,  178,
    0,    0,  248,    0,    0,    0,    0,  109,    0,  110,
    0,    0,  240,    0,    0,  241,  242,  261,    0,  249,
  250,  112,  350,  243,  113,  244,  245,    0,    0,    0,
  351,  246,  247,  116,  117,  118,    0,    0,  104,    0,
    0,    0,  105,  106,  107,  239,    0,  119,  108,  120,
    0,    0,  121,  122,  123,  124,    0,    0,    0,  248,
    0,    0,    0,    0,  109,    0,  110,    0,    0,  240,
    0,    0,  241,  242,    0,    0,  249,  250,  112,  170,
  243,  113,  244,  245,    0,    0,    0,    0,  246,  247,
  116,  117,  118,    0,    0,  104,    0,    0,    0,  105,
  106,  107,  239,    0,  119,  108,  120,    0,    0,  121,
  122,  123,  124,    0,    0,    0,  248,    0,    0,    0,
    0,  109,    0,  110,    0,    0,  240,    0,    0,  241,
  242,    0,    0,  249,  250,  112,    0,  243,  113,  244,
  245,  188,    0,    0,    0,  246,  247,  116,  117,  118,
    0,    0,  104,    0,    0,    0,  105,  106,  107,  239,
    0,  119,  108,  120,    0,    0,  121,  122,  123,  124,
    0,    0,    0,  248,    0,    0,    0,    0,  109,    0,
  110,    0,    0,  240,    0,    0,  241,  242,    0,    0,
  249,  250,  112,    0,  243,  113,  244,  245,    0,    0,
    0,  351,  246,  247,  116,  117,  118,    0,    0,  104,
    0,    0,    0,  105,  106,  107,  239,    0,  119,  108,
  120,    0,    0,  121,  122,  123,  124,    0,    0,    0,
  248,    0,    0,    0,    0,  109,    0,  110,    0,    0,
  240,    0,    0,  241,  242,    0,    0,  249,  250,  112,
    0,  243,  113,  244,  245,    0,    0,    0,    0,  246,
  247,  116,  117,  118,    0,    0,  104,    0,    0,    0,
  105,  106,  107,  239,    0,  119,  108,  120,    0,    0,
  121,  122,  123,  124,    0,    0,    0,  248,    0,    0,
    0,    0,  109,    0,  110,    0,    0,  240,    0,    0,
  241,  303,    0,    0,  249,  250,  112,    0,  243,  113,
  304,  245,    0,    0,    0,    0,  246,  247,  116,  117,
  118,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  119,    0,  120,    0,    0,  121,  122,  123,
  124,  104,    0,    0,  248,  105,  106,  107,    0,    0,
    0,  108,    0,    0,  363,  364,    0,    0,    0,    0,
    0,  249,  250,    0,    0,    0,    0,  109,    0,  110,
    0,    0,    0,    0,    0,    0,  111,    0,    0,    0,
    0,  112,  170,    0,  113,    0,    0,    0,    0,    0,
    0,  114,  115,  116,  117,  118,  104,    0,    0,    0,
  105,  106,  107,    0,    0,    0,  108,  119,    0,  120,
    0,    0,  121,  122,  123,  124,    0,    0,    0,    0,
    0,    0,  109,    0,  110,    0,    0,    0,    0,    0,
    0,  111,    0,    0,    0,    0,  112,  170,    0,  113,
    0,    0,    0,    0,    0,    0,  114,  115,  116,  117,
  118,  104,    0,    0,    0,  105,  106,  107,    0,    0,
    0,  108,  119,    0,  120,    0,    0,  121,  122,  123,
  124,    0,    0,    0,    0,    0,    0,  109,    0,  110,
    0,    0,    0,    0,    0,    0,  111,    0,    0,    0,
    0,  112,    0,    0,  113,    0,    0,    0,    0,    0,
    0,  114,  115,  116,  117,  118,  186,    0,    0,    0,
  186,  186,  186,    0,    0,    0,  186,  119,    0,  120,
    0,    0,  121,  122,  123,  124,    0,    0,    0,    0,
    0,    0,  186,    0,  186,    0,    0,    0,    0,    0,
    0,  186,    0,    0,    0,    0,  186,    0,    0,  186,
    0,    0,    0,    0,    0,    0,  186,  186,  186,  186,
  186,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  186,    0,  186,    0,    0,  186,  186,  186,
  186,
};
short yycheck[] = {                                       1,
    4,  274,  260,  285,  286,  214,    8,  270,  136,   13,
  257,  262,  187,  178,  274,  270,  261,  261,   22,  268,
  274,  121,  294,  123,  270,  398,  301,  275,  301,   31,
  339,  270,   34,  133,  134,  283,  281,  292,  270,  348,
  277,  301,   44,  291,  121,  277,  123,   49,   50,   51,
  279,  333,   54,  335,  347,  300,  305,  350,  305,  270,
  323,  434,   64,  321,   66,  270,  194,  318,  243,  197,
  198,  246,  319,  270,  322,  348,   93,  323,  315,  254,
  338,  326,  326,  315,  323,  257,  359,  360,  361,  270,
   92,  323,  109,  258,  271,  272,  359,  360,  361,  359,
  360,  361,  356,  357,  358,  107,  108,  270,  110,  111,
  112,  113,  323,  413,  277,  270,  416,  119,  323,  121,
  286,  123,  280,  125,  406,  270,  323,  336,  294,  131,
  132,  133,  134,  305,  301,  235,  257,  309,  238,  421,
  336,  143,  323,  309,  319,  176,  305,  319,  179,  314,
  294,  182,  315,  170,  336,  301,  268,  280,  160,  276,
  323,  282,  164,  314,  168,  309,  341,  284,  323,  171,
  298,  299,  300,  301,  176,  350,  294,  179,  323,  344,
  182,  262,  199,  334,  305,  294,  128,  129,  309,  326,
  289,  208,  359,  360,  361,  323,  324,  296,  319,  258,
  309,  203,  353,  320,  206,  207,  286,  179,  280,  211,
  182,  328,  214,  359,  360,  361,  339,  340,  341,  342,
  385,  344,  345,  346,  347,  318,  349,  350,  294,  357,
  405,  270,  314,  235,  206,  207,  238,  303,  294,  288,
  242,  243,  259,  309,  297,  329,  276,  303,  413,  316,
  294,  416,  334,  309,  284,  329,  286,  323,  268,  303,
  277,  278,  264,  278,  294,  309,  335,  339,  340,  341,
  342,  353,  344,  345,  346,  347,  404,  349,  350,  309,
  340,  294,  261,  285,  286,  342,  341,  344,  290,  353,
  320,  270,  349,  295,  307,  274,  309,  276,  328,  294,
  428,  303,  281,  300,  317,  284,  294,  286,  303,  294,
  335,  294,  346,  295,  309,  332,   41,  334,   43,  307,
  303,  309,  259,  327,  309,  339,  309,  276,  323,  317,
  332,  333,  334,  335,  336,  284,  267,  286,  355,  356,
  348,  320,  344,  305,  323,  294,  348,  326,  365,  328,
  301,   76,   77,   78,   79,  276,  373,  374,  294,  279,
  309,  378,  351,  284,  351,  286,   91,   56,  343,   58,
  314,  320,  301,  294,  294,  100,  297,  294,  345,  328,
   69,  398,  314,  385,  309,  351,  303,  307,  309,  309,
  274,  309,  309,   82,   83,  301,  301,  317,  324,  320,
  417,  261,  281,  420,  406,  300,  305,  328,  294,  329,
  323,  413,  270,  270,  416,  326,  259,  434,  261,  421,
  263,  264,  265,  266,  301,  268,  269,  270,  356,  357,
  358,  303,  275,  276,  277,  359,  360,  361,  326,  314,
  283,  284,  285,  286,  287,  323,  270,  290,  291,  323,
  293,  294,  294,  270,  270,  323,  299,  270,  301,  302,
  303,  304,  305,  303,  323,  268,  309,  310,  311,  312,
  313,  323,  315,  262,  329,    0,  329,  320,  329,  322,
  323,  301,  325,  326,  327,  328,  323,  330,  331,  332,
  333,  326,  323,  281,  337,  323,  339,  323,  323,  120,
  323,  295,  112,   85,   50,  348,  132,  131,  420,  365,
  220,  354,  355,  356,  357,  358,  259,  328,  261,  334,
  263,  264,  265,  266,  203,  268,  269,  270,  327,  341,
  406,   13,  275,  276,  277,   22,   51,   74,  195,  316,
  283,  284,  285,  286,  287,  350,  348,  290,  291,  385,
  293,  294,   -1,   -1,   -1,   -1,  299,   -1,  301,  302,
  303,  304,  305,   -1,   -1,   -1,  309,  310,  311,  312,
  313,   -1,  315,   -1,   -1,   -1,   -1,  320,   -1,  322,
  323,   -1,  325,  326,  327,  328,   -1,  330,  331,  332,
  333,   -1,   -1,   -1,  337,   -1,  339,  339,  340,  341,
  342,   -1,  344,  345,  346,  347,   -1,  349,  350,   -1,
   -1,  354,  355,  356,  357,  358,  259,   -1,  261,   -1,
  263,  264,  265,  266,   -1,  268,  269,  270,   -1,   -1,
   -1,   -1,  275,  276,  277,   -1,   -1,   -1,   -1,   -1,
  283,  284,  285,  286,  287,   -1,   -1,  290,  291,   -1,
  293,  294,   -1,   -1,   -1,   -1,  299,   -1,  301,  302,
  303,  304,  305,   -1,   -1,   -1,  309,  310,  311,  312,
  313,   -1,  315,   -1,   -1,   -1,   -1,  320,   -1,  322,
  323,   -1,  325,  326,  327,  328,   -1,  330,  331,  332,
  333,   -1,   -1,   -1,  337,   -1,   -1,   -1,   -1,   -1,
  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  354,  355,  356,  357,  358,  259,   -1,  261,   -1,
  263,  264,  265,  266,   -1,   -1,  269,  270,   -1,   -1,
   -1,  274,  275,  276,   -1,   -1,   -1,   -1,  281,   -1,
  283,  284,  285,  286,  287,   -1,   -1,  290,  291,   -1,
  293,  294,   -1,   -1,   -1,   -1,  299,  300,  301,  302,
  303,  304,  305,  294,   -1,   -1,  309,  310,  311,  312,
  313,   -1,  303,   -1,   -1,   -1,   -1,  320,  309,  322,
  323,   -1,  325,  326,  327,  328,   -1,  330,  331,  332,
  333,   -1,  323,  324,  337,  326,   -1,   -1,   -1,   -1,
  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  354,  355,  356,  357,  358,  259,   -1,  261,   -1,
  263,  264,  265,  266,   -1,   -1,  269,  270,   -1,   -1,
   -1,  274,  275,  276,   -1,   -1,   -1,   -1,  281,   -1,
  283,  284,  285,  286,  287,   -1,   -1,  290,  291,   -1,
  293,  294,   -1,   -1,   -1,   -1,  299,  300,  301,  302,
  303,  304,  305,   -1,   -1,   -1,  309,  310,  311,  312,
  313,   -1,   -1,   -1,   -1,   -1,   -1,  320,   -1,  322,
  323,   -1,  325,  326,  327,  328,   -1,  330,  331,  332,
  333,   -1,   -1,   -1,  337,   -1,   -1,   -1,   -1,   -1,
  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  354,  355,  356,  357,  358,  259,   -1,  261,   -1,
  263,  264,  265,  266,   -1,  268,  269,  270,   -1,   -1,
   -1,   -1,  275,  276,  277,   -1,   -1,   -1,   -1,   -1,
  283,  284,  285,  286,  287,   -1,   -1,  290,  291,   -1,
  293,  294,   -1,   -1,   -1,   -1,  299,   -1,  301,  302,
  303,  304,  305,   -1,   -1,   -1,  309,  310,  311,  312,
  313,   -1,  315,   -1,   -1,   -1,   -1,  320,   -1,  322,
  323,   -1,  325,  326,  327,  328,   -1,  330,  331,  332,
  333,   -1,   -1,   -1,  337,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  354,  355,  356,  357,  358,  259,   -1,  261,   -1,
  263,  264,  265,  266,   -1,  268,  269,  270,   -1,   -1,
   -1,   -1,  275,  276,  277,   -1,   -1,   -1,   -1,   -1,
  283,  284,  285,  286,  287,   -1,   -1,  290,  291,   -1,
  293,  294,   -1,   -1,   -1,   -1,  299,   -1,  301,  302,
  303,  304,  305,   -1,   -1,   -1,  309,  310,  311,  312,
  313,   -1,  315,   -1,   -1,   -1,   -1,  320,   -1,  322,
  323,   -1,  325,  326,  327,  328,   -1,  330,  331,  332,
  333,   -1,   -1,   -1,  337,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  354,  355,  356,  357,  358,  259,   -1,  261,   -1,
  263,  264,  265,  266,   -1,   -1,  269,  270,   -1,   -1,
   -1,  274,  275,  276,   -1,   -1,   -1,   -1,  281,   -1,
  283,  284,  285,  286,  287,   -1,   -1,  290,  291,   -1,
  293,  294,   -1,   -1,   -1,   -1,  299,  300,  301,  302,
  303,  304,  305,   -1,   -1,   -1,  309,  310,  311,  312,
  313,   -1,   -1,   -1,   -1,   -1,   -1,  320,   -1,  322,
  323,   -1,  325,  326,  327,  328,   -1,  330,  331,  332,
  333,   -1,   -1,   -1,  337,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  354,  355,  356,  357,  358,  259,   -1,  261,   -1,
  263,  264,  265,  266,   -1,  268,  269,  270,   -1,   -1,
   -1,   -1,  275,  276,  277,   -1,   -1,   -1,   -1,   -1,
  283,  284,  285,  286,  287,   -1,   -1,  290,  291,   -1,
  293,  294,   -1,   -1,   -1,   -1,  299,   -1,  301,  302,
  303,  304,   -1,   -1,   -1,   -1,  309,  310,  311,  312,
  313,   -1,  315,   -1,   -1,   -1,   -1,  320,   -1,  322,
  323,   -1,  325,  326,  327,  328,   -1,  330,  331,  332,
  333,   -1,   -1,   -1,  337,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  354,  355,  356,  357,  358,  259,   -1,  261,   -1,
  263,  264,  265,  266,   -1,  268,  269,  270,   -1,   -1,
   -1,   -1,  275,  276,  277,   -1,   -1,   -1,   -1,   -1,
  283,  284,  285,  286,  287,   -1,   -1,  290,  291,   -1,
  293,  294,   -1,   -1,   -1,   -1,  299,   -1,   -1,  302,
  303,  304,  305,   -1,   -1,   -1,  309,  310,  311,  312,
  313,   -1,  315,   -1,   -1,   -1,   -1,  320,   -1,  322,
  323,   -1,  325,  326,  327,  328,   -1,  330,  331,  332,
  333,   -1,   -1,   -1,  337,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  354,  355,  356,  357,  358,  259,   -1,  261,   -1,
  263,  264,  265,  266,   -1,  268,  269,  270,   -1,   -1,
   -1,   -1,  275,  276,  277,   -1,   -1,   -1,   -1,   -1,
  283,  284,  285,  286,  287,   -1,   -1,  290,  291,   -1,
  293,  294,   -1,   -1,   -1,   -1,  299,   -1,  301,  302,
  303,  304,   -1,   -1,   -1,   -1,  309,  310,  311,  312,
  313,   -1,  315,   -1,   -1,   -1,   -1,  320,   -1,  322,
  323,   -1,  325,  326,  327,  328,   -1,  330,  331,  332,
  333,   -1,   -1,   -1,  337,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  354,  355,  356,  357,  358,  259,   -1,  261,   -1,
  263,  264,  265,  266,   -1,  268,  269,  270,   -1,   -1,
   -1,   -1,  275,  276,  277,   -1,   -1,   -1,   -1,   -1,
  283,  284,  285,  286,  287,   -1,   -1,  290,  291,   -1,
  293,  294,   -1,   -1,   -1,   -1,  299,   -1,  301,  302,
  303,  304,   -1,   -1,   -1,   -1,  309,  310,  311,  312,
  313,   -1,  315,   -1,   -1,   -1,   -1,  320,   -1,  322,
  323,   -1,  325,  326,  327,  328,   -1,  330,  331,  332,
  333,   -1,   -1,   -1,  337,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  354,  355,  356,  357,  358,  259,   -1,  261,   -1,
  263,  264,  265,  266,   -1,  268,  269,  270,   -1,   -1,
   -1,   -1,  275,  276,  277,   -1,   -1,   -1,   -1,   -1,
  283,  284,  285,  286,  287,   -1,   -1,  290,  291,   -1,
  293,  294,   -1,   -1,   -1,   -1,  299,   -1,  301,  302,
  303,  304,   -1,   -1,   -1,   -1,  309,  310,  311,  312,
  313,   -1,  315,   -1,   -1,   -1,   -1,  320,   -1,  322,
  323,   -1,  325,  326,  327,  328,   -1,  330,  331,  332,
  333,   -1,   -1,   -1,  337,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  354,  355,  356,  357,  358,  259,   -1,  261,   -1,
  263,  264,  265,  266,   -1,  268,  269,  270,   -1,   -1,
   -1,   -1,  275,  276,  277,   -1,   -1,   -1,   -1,   -1,
  283,  284,  285,  286,  287,   -1,   -1,  290,  291,   -1,
  293,  294,   -1,   -1,   -1,   -1,  299,   -1,  301,  302,
  303,  304,   -1,   -1,   -1,   -1,  309,  310,  311,  312,
  313,   -1,  315,   -1,   -1,   -1,   -1,  320,   -1,  322,
  323,   -1,  325,  326,  327,  328,   -1,  330,  331,  332,
  333,   -1,   -1,   -1,  337,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  354,  355,  356,  357,  358,  259,   -1,  261,   -1,
  263,  264,  265,  266,   -1,  268,  269,  270,   -1,   -1,
   -1,   -1,  275,  276,  277,   -1,   -1,   -1,   -1,   -1,
  283,  284,  285,  286,  287,   -1,   -1,  290,  291,   -1,
  293,  294,   -1,   -1,   -1,   -1,  299,   -1,  301,  302,
  303,  304,   -1,   -1,   -1,   -1,  309,  310,  311,  312,
  313,   -1,  315,   -1,   -1,   -1,   -1,  320,   -1,  322,
  323,   -1,  325,  326,  327,  328,   -1,  330,  331,  332,
  333,   -1,   -1,   -1,  337,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  354,  355,  356,  357,  358,  259,   -1,  261,   -1,
  263,  264,  265,  266,   -1,  268,  269,  270,   -1,   -1,
   -1,   -1,  275,  276,  277,   -1,   -1,   -1,   -1,   -1,
  283,  284,  285,  286,  287,   -1,   -1,  290,  291,   -1,
  293,  294,   -1,   -1,   -1,   -1,  299,   -1,  301,  302,
  303,  304,   -1,   -1,   -1,   -1,  309,  310,  311,  312,
  313,   -1,  315,   -1,   -1,   -1,   -1,  320,   -1,  322,
  323,   -1,  325,  326,  327,  328,   -1,  330,  331,  332,
  333,   -1,   -1,   -1,  337,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  354,  355,  356,  357,  358,  259,   -1,  261,   -1,
  263,  264,  265,  266,   -1,  268,  269,  270,   -1,   -1,
   -1,   -1,  275,  276,  277,   -1,   -1,   -1,   -1,   -1,
  283,  284,  285,  286,  287,   -1,   -1,  290,  291,   -1,
  293,  294,   -1,   -1,   -1,   -1,  299,   -1,  301,  302,
  303,  304,   -1,   -1,   -1,   -1,  309,  310,  311,  312,
  313,   -1,  315,   -1,   -1,   -1,   -1,  320,   -1,  322,
  323,   -1,  325,  326,  327,  328,   -1,  330,  331,  332,
  333,   -1,   -1,   -1,  337,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  354,  355,  356,  357,  358,  259,   -1,  261,   -1,
  263,  264,  265,  266,   -1,  268,  269,  270,   -1,   -1,
   -1,   -1,  275,  276,  277,   -1,   -1,   -1,   -1,   -1,
  283,  284,  285,  286,  287,   -1,   -1,  290,  291,   -1,
  293,  294,   -1,   -1,   -1,   -1,  299,   -1,  301,  302,
  303,  304,   -1,   -1,   -1,   -1,  309,  310,  311,  312,
  313,   -1,  315,   -1,   -1,   -1,   -1,  320,   -1,  322,
  323,   -1,  325,  326,  327,  328,   -1,  330,  331,  332,
  333,  259,   -1,  261,  337,  263,  264,  265,  266,   -1,
  268,  269,  270,   -1,   -1,   -1,   -1,   -1,  276,  277,
   -1,  354,  355,  356,  357,  358,  284,  285,  286,  287,
   -1,   -1,  290,   -1,   -1,  293,  294,   -1,   -1,   -1,
   -1,  299,   -1,  301,  302,  303,  304,  305,   -1,   -1,
   -1,  309,  310,  311,  312,  313,   -1,  315,   -1,   -1,
   -1,   -1,  320,   -1,   -1,  323,   -1,  325,  326,  327,
  328,   -1,  330,  331,  332,  333,  259,   -1,  261,  337,
  263,  264,  265,  266,   -1,  268,  269,  270,   -1,   -1,
   -1,   -1,   -1,  276,  277,   -1,  354,  355,  356,  357,
  358,  284,  285,  286,  287,   -1,   -1,  290,   -1,   -1,
  293,  294,   -1,   -1,   -1,   -1,  299,   -1,  301,  302,
  303,  304,  305,   -1,   -1,   -1,  309,  310,  311,  312,
  313,   -1,  315,   -1,   -1,   -1,   -1,  320,   -1,   -1,
  323,   -1,  325,  326,  327,  328,   -1,  330,  331,  332,
  333,   -1,  259,   -1,  337,   -1,  263,  264,  265,  266,
   -1,   -1,  269,  270,   -1,   -1,   -1,   -1,  275,   -1,
   -1,  354,  355,  356,  357,  358,  283,   -1,  285,   -1,
  287,   -1,   -1,  290,  291,   -1,  293,  294,   -1,   -1,
   -1,   -1,  299,   -1,  301,  302,  303,  304,  305,   -1,
   -1,   -1,  309,  310,  311,  312,  313,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  322,  323,   -1,  325,   -1,
  327,   -1,   -1,  330,  331,  332,  333,   -1,  259,   -1,
  337,   -1,  263,  264,  265,  266,  343,   -1,  269,  270,
   -1,   -1,   -1,   -1,  275,   -1,   -1,  354,  355,  356,
  357,  358,  283,   -1,  285,   -1,  287,   -1,   -1,  290,
  291,   -1,  293,  294,   -1,   -1,   -1,   -1,  299,   -1,
  301,  302,  303,  304,  305,   -1,   -1,   -1,  309,  310,
  311,  312,  313,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  322,  323,   -1,  325,   -1,  327,   -1,   -1,  330,
  331,  332,  333,  259,   -1,   -1,  337,  263,  264,  265,
   -1,   -1,  343,  269,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  354,  355,  356,  357,  358,   -1,  285,
   -1,  287,   -1,  289,   -1,   -1,   -1,   -1,  294,   -1,
  296,   -1,   -1,  299,   -1,   -1,  302,   -1,   -1,   -1,
   -1,   -1,   -1,  309,  310,  311,  312,  313,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  325,
   -1,  327,   -1,   -1,  330,  331,  332,  333,  259,   -1,
   -1,   -1,  263,  264,  265,   -1,   -1,   -1,  269,   -1,
   -1,  272,  273,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  356,  357,  358,   -1,  285,   -1,  287,   -1,   -1,   -1,
   -1,   -1,   -1,  294,   -1,   -1,   -1,   -1,  299,   -1,
   -1,  302,   -1,   -1,   -1,   -1,   -1,   -1,  309,  310,
  311,  312,  313,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  325,   -1,  327,   -1,   -1,  330,
  331,  332,  333,  259,   -1,   -1,   -1,  263,  264,  265,
   -1,   -1,   -1,  269,   -1,   -1,   -1,   -1,  274,   -1,
   -1,   -1,   -1,   -1,   -1,  356,  357,  358,   -1,  285,
   -1,  287,   -1,   -1,   -1,   -1,   -1,   -1,  294,   -1,
   -1,   -1,   -1,  299,   -1,   -1,  302,   -1,   -1,   -1,
   -1,   -1,   -1,  309,  310,  311,  312,  313,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  325,
   -1,  327,   -1,   -1,  330,  331,  332,  333,  259,   -1,
   -1,   -1,  263,  264,  265,   -1,   -1,   -1,  269,   -1,
   -1,   -1,  348,  274,   -1,   -1,   -1,   -1,   -1,   -1,
  356,  357,  358,   -1,  285,   -1,  287,   -1,   -1,   -1,
   -1,   -1,   -1,  294,   -1,   -1,   -1,   -1,  299,   -1,
   -1,  302,   -1,   -1,   -1,   -1,   -1,   -1,  309,  310,
  311,  312,  313,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  325,   -1,  327,   -1,   -1,  330,
  331,  332,  333,  259,   -1,   -1,   -1,  263,  264,  265,
   -1,   -1,   -1,  269,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  356,  357,  358,   -1,  285,
   -1,  287,   -1,   -1,   -1,   -1,   -1,   -1,  294,   -1,
   -1,   -1,   -1,  299,   -1,   -1,  302,   -1,   -1,   -1,
   -1,   -1,   -1,  309,  310,  311,  312,  313,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  325,
   -1,  327,   -1,   -1,  330,  331,  332,  333,  259,   -1,
   -1,   -1,  263,  264,  265,   -1,   -1,   -1,  269,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  356,  357,  358,   -1,  285,   -1,  287,   -1,   -1,   -1,
   -1,   -1,   -1,  294,   -1,   -1,   -1,   -1,  299,   -1,
   -1,  302,   -1,   -1,   -1,   -1,   -1,   -1,  309,  310,
  311,  312,  313,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  325,   -1,  327,   -1,   -1,  330,
  331,  332,  333,  259,   -1,   -1,   -1,  263,  264,  265,
   -1,   -1,   -1,  269,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  356,  357,  358,   -1,  285,
   -1,  287,   -1,   -1,   -1,   -1,   -1,   -1,  294,   -1,
   -1,   -1,   -1,  299,   -1,   -1,  302,   -1,   -1,   -1,
   -1,   -1,   -1,  309,  310,  311,  312,  313,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  325,
   -1,  327,   -1,   -1,  330,  331,  332,  333,   -1,  259,
   -1,  261,   -1,  263,  264,  265,  266,   -1,  268,  269,
  270,   -1,   -1,   -1,   -1,  275,  276,  277,   -1,   -1,
  356,  357,  358,  283,  284,  285,  286,  287,   -1,   -1,
  290,  291,   -1,  293,  294,   -1,   -1,   -1,   -1,  299,
   -1,  301,  302,  303,  304,  305,   -1,   -1,   -1,  309,
  310,  311,  312,  313,   -1,  315,   -1,   -1,   -1,   -1,
  320,   -1,  322,  323,   -1,  325,  326,  327,  328,   -1,
  330,  331,  332,  333,  259,   -1,  261,  337,  263,  264,
  265,  266,   -1,  268,  269,  270,   -1,   -1,   -1,   -1,
  275,  276,  277,   -1,  354,  355,   -1,   -1,  283,  284,
  285,  286,  287,   -1,   -1,  290,  291,   -1,  293,  294,
   -1,   -1,   -1,   -1,  299,   -1,  301,  302,  303,  304,
  305,   -1,   -1,   -1,  309,  310,  311,  312,  313,   -1,
  315,   -1,   -1,   -1,   -1,  320,   -1,  322,  323,   -1,
  325,  326,  327,  328,   -1,  330,  331,  332,  333,  259,
   -1,  261,  337,  263,  264,  265,  266,   -1,  268,  269,
  270,   -1,   -1,   -1,   -1,  275,  276,  277,   -1,  354,
  355,   -1,   -1,  283,  284,  285,  286,  287,   -1,   -1,
  290,  291,   -1,  293,  294,   -1,   -1,   -1,   -1,  299,
   -1,  301,  302,  303,  304,  305,   -1,   -1,   -1,  309,
  310,  311,  312,  313,   -1,  315,   -1,   -1,   -1,   -1,
  320,   -1,  322,  323,   -1,  325,  326,  327,  328,   -1,
  330,  331,  332,  333,  259,   -1,   -1,  337,  263,  264,
  265,  266,   -1,   -1,  269,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  354,  355,   -1,   -1,   -1,   -1,
  285,   -1,  287,   -1,   -1,  290,   -1,  292,  293,  294,
   -1,   -1,   -1,  298,  299,   -1,  301,  302,  303,  304,
   -1,  306,   -1,   -1,  309,  310,  311,  312,  313,   -1,
   -1,  259,   -1,   -1,   -1,  263,  264,  265,  266,   -1,
  325,  269,  327,   -1,   -1,  330,  331,  332,  333,  334,
   -1,   -1,  337,   -1,   -1,   -1,   -1,  285,   -1,  287,
   -1,   -1,  290,   -1,   -1,  293,  294,  352,   -1,  354,
  355,  299,  300,  301,  302,  303,  304,   -1,   -1,   -1,
  308,  309,  310,  311,  312,  313,   -1,   -1,  259,   -1,
   -1,   -1,  263,  264,  265,  266,   -1,  325,  269,  327,
   -1,   -1,  330,  331,  332,  333,   -1,   -1,   -1,  337,
   -1,   -1,   -1,   -1,  285,   -1,  287,   -1,   -1,  290,
   -1,   -1,  293,  294,   -1,   -1,  354,  355,  299,  300,
  301,  302,  303,  304,   -1,   -1,   -1,   -1,  309,  310,
  311,  312,  313,   -1,   -1,  259,   -1,   -1,   -1,  263,
  264,  265,  266,   -1,  325,  269,  327,   -1,   -1,  330,
  331,  332,  333,   -1,   -1,   -1,  337,   -1,   -1,   -1,
   -1,  285,   -1,  287,   -1,   -1,  290,   -1,   -1,  293,
  294,   -1,   -1,  354,  355,  299,   -1,  301,  302,  303,
  304,  305,   -1,   -1,   -1,  309,  310,  311,  312,  313,
   -1,   -1,  259,   -1,   -1,   -1,  263,  264,  265,  266,
   -1,  325,  269,  327,   -1,   -1,  330,  331,  332,  333,
   -1,   -1,   -1,  337,   -1,   -1,   -1,   -1,  285,   -1,
  287,   -1,   -1,  290,   -1,   -1,  293,  294,   -1,   -1,
  354,  355,  299,   -1,  301,  302,  303,  304,   -1,   -1,
   -1,  308,  309,  310,  311,  312,  313,   -1,   -1,  259,
   -1,   -1,   -1,  263,  264,  265,  266,   -1,  325,  269,
  327,   -1,   -1,  330,  331,  332,  333,   -1,   -1,   -1,
  337,   -1,   -1,   -1,   -1,  285,   -1,  287,   -1,   -1,
  290,   -1,   -1,  293,  294,   -1,   -1,  354,  355,  299,
   -1,  301,  302,  303,  304,   -1,   -1,   -1,   -1,  309,
  310,  311,  312,  313,   -1,   -1,  259,   -1,   -1,   -1,
  263,  264,  265,  266,   -1,  325,  269,  327,   -1,   -1,
  330,  331,  332,  333,   -1,   -1,   -1,  337,   -1,   -1,
   -1,   -1,  285,   -1,  287,   -1,   -1,  290,   -1,   -1,
  293,  294,   -1,   -1,  354,  355,  299,   -1,  301,  302,
  303,  304,   -1,   -1,   -1,   -1,  309,  310,  311,  312,
  313,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  325,   -1,  327,   -1,   -1,  330,  331,  332,
  333,  259,   -1,   -1,  337,  263,  264,  265,   -1,   -1,
   -1,  269,   -1,   -1,  272,  273,   -1,   -1,   -1,   -1,
   -1,  354,  355,   -1,   -1,   -1,   -1,  285,   -1,  287,
   -1,   -1,   -1,   -1,   -1,   -1,  294,   -1,   -1,   -1,
   -1,  299,  300,   -1,  302,   -1,   -1,   -1,   -1,   -1,
   -1,  309,  310,  311,  312,  313,  259,   -1,   -1,   -1,
  263,  264,  265,   -1,   -1,   -1,  269,  325,   -1,  327,
   -1,   -1,  330,  331,  332,  333,   -1,   -1,   -1,   -1,
   -1,   -1,  285,   -1,  287,   -1,   -1,   -1,   -1,   -1,
   -1,  294,   -1,   -1,   -1,   -1,  299,  300,   -1,  302,
   -1,   -1,   -1,   -1,   -1,   -1,  309,  310,  311,  312,
  313,  259,   -1,   -1,   -1,  263,  264,  265,   -1,   -1,
   -1,  269,  325,   -1,  327,   -1,   -1,  330,  331,  332,
  333,   -1,   -1,   -1,   -1,   -1,   -1,  285,   -1,  287,
   -1,   -1,   -1,   -1,   -1,   -1,  294,   -1,   -1,   -1,
   -1,  299,   -1,   -1,  302,   -1,   -1,   -1,   -1,   -1,
   -1,  309,  310,  311,  312,  313,  259,   -1,   -1,   -1,
  263,  264,  265,   -1,   -1,   -1,  269,  325,   -1,  327,
   -1,   -1,  330,  331,  332,  333,   -1,   -1,   -1,   -1,
   -1,   -1,  285,   -1,  287,   -1,   -1,   -1,   -1,   -1,
   -1,  294,   -1,   -1,   -1,   -1,  299,   -1,   -1,  302,
   -1,   -1,   -1,   -1,   -1,   -1,  309,  310,  311,  312,
  313,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  325,   -1,  327,   -1,   -1,  330,  331,  332,
  333,
};
#define YYFINAL 2
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 361
#if YYDEBUG
char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"ABSENT","ACTION","ANY",
"APPLICATION","BAR","BGIN","BIT","BITSTRING","BOOLEAN","BSTRING","BY","CCE",
"CHOICE","COMMA","COMPONENT","COMPONENTS","COMPONENTSOF","CONTROL","DEC_FN",
"DECODER","DEFAULT","DEFINED","DEFINITIONS","DOT","DOTDOT","DOTDOTDOT","ENC_FN",
"ENCODER","ENCRYPTED","END","ENUMERATED","EXPORTS","EXPLICIT","L_FALSE",
"FRE_FN","FROM","HSTRING","ID","IDENTIFIER","IMPLICIT","IMPORTS","INCLUDES",
"INTEGER","LANGLE","LBRACE","LBRACKET","LITNUMBER","LITSTRING","LPAREN","MIN",
"MINUS","MAX","NAME","NIL","OBJECT","OCTET","OCTETSTRING","OF","OPTIONAL",
"PARAMETERTYPE","PLUS","PREFIXES","PRESENT","PRINTER","PRIVATE","PRT_FN",
"RBRACE","RBRACKET","REAL","RPAREN","STAR","SECTIONS","SEMICOLON","SEQUENCE",
"SEQUENCEOF","SET","SETOF","SIZE","STRING","TAGS","L_TRUE","UNIVERSAL","VALA",
"VALB","VALI","VALS","VALP","VALO","VALOID","VALR","VALT","VALTYPE","VALQ",
"VALX","VLENGTH","WITH","SCTRL","PLUSINFINITY","MINUSINFINITY","EACTION",
"DACTION","PACTION","ECHOICE","DCHOICE","PCHOICE",
};
char *yyrule[] = {
"$accept : ModuleDefinition",
"$$1 :",
"$$2 :",
"ModuleDefinition : ModuleIdentifier DEFINITIONS TagDefault CCE $$1 ModuleActions ModulePrefixes $$2 BGIN ModuleBody END ModuleActions",
"TagDefault : EXPLICIT TAGS",
"TagDefault : IMPLICIT TAGS",
"TagDefault : empty",
"ModuleIdentifier : ID AssignedIdentifier",
"AssignedIdentifier : ObjectIdentifierValue",
"AssignedIdentifier : empty",
"ModuleActions : ACTION",
"ModuleActions : empty",
"ModulePrefixes : PREFIXES String String String",
"ModulePrefixes : empty",
"ModuleBody : Exports Imports AssignmentList",
"$$3 :",
"Exports : EXPORTS $$3 SymbolsExported SEMICOLON",
"Exports : empty",
"SymbolsExported : SymbolList",
"SymbolsExported : empty",
"$$4 :",
"Imports : IMPORTS $$4 SymbolsImported SEMICOLON",
"Imports : empty",
"SymbolsImported : SymbolsFromModuleList",
"SymbolsImported : empty",
"SymbolsFromModuleList : SymbolsFromModuleList SymbolsFromModule",
"SymbolsFromModuleList : SymbolsFromModule",
"SymbolsFromModule : SymbolList FROM ModuleIdentifier",
"SymbolList : SymbolList COMMA Symbol",
"SymbolList : Symbol",
"SymbolList : SymbolList COMMA MINUS Symbol",
"SymbolList : MINUS Symbol",
"SymbolList : SymbolList COMMA PLUS Symbol",
"SymbolList : PLUS Symbol",
"Symbol : ID",
"Symbol : NAME",
"AssignmentList : AssignmentList Section Assignment",
"AssignmentList : empty",
"Section : ENCODER String",
"Section : DECODER String",
"Section : PRINTER String",
"Section : SECTIONS String String String",
"Section : empty",
"String : ID",
"String : NAME",
"Assignment : Typeassignment",
"Assignment : Valueassignment",
"UAction : UAction EACTION",
"UAction : UAction DACTION",
"UAction : UAction PACTION",
"UAction : empty",
"CAction : CAction ECHOICE",
"CAction : CAction DCHOICE",
"CAction : CAction PCHOICE",
"CAction : empty",
"Typeassignment : ID ParameterType CCE UAction Type",
"Type : BuiltinType CodingFn UAction",
"Type : DefinedType CodingFn UAction",
"Type : SubType CodingFn UAction",
"Control : CONTROL",
"Control : empty",
"ParameterType : PARAMETERTYPE",
"ParameterType : empty",
"Valtype : VALTYPE",
"Valtype : empty",
"BuiltinType : BOOLEAN PassBool",
"BuiltinType : INTEGER PassInt NNlist",
"BuiltinType : ENUMERATED PassInt LBRACE NamedNumberList RBRACE",
"BuiltinType : Bitstring PassBit NNlist",
"BuiltinType : Octetstring PassString",
"BuiltinType : NIL",
"BuiltinType : SEQUENCE Sctrl PassAny",
"BuiltinType : SequenceOf Sctrl Valtype Control UAction Type",
"BuiltinType : SEQUENCE Sctrl Valtype LBRACE UAction ElementTypes RBRACE",
"BuiltinType : SET Sctrl PassAny",
"BuiltinType : SetOf Sctrl Valtype Control UAction Type",
"BuiltinType : SET Sctrl Valtype LBRACE UAction MemberTypes RBRACE",
"BuiltinType : Tag UAction IMPLICIT Type",
"BuiltinType : Tag UAction EXPLICIT Type",
"BuiltinType : Tag UAction Type",
"BuiltinType : CHOICE Sctrl Valtype Control CAction LBRACE UAction AlternativeTypeList RBRACE",
"BuiltinType : NAME LANGLE Type",
"BuiltinType : AnyType PassAny",
"BuiltinType : STAR AnyType PassAny",
"BuiltinType : OBJECT IDENTIFIER PassOid",
"BuiltinType : ENCRYPTED Type",
"BuiltinType : REAL PassReal",
"NNlist : LBRACE NamedNumberList RBRACE",
"NNlist : empty",
"DefinedType : ID PassValue ValParameter",
"DefinedType : ID DOT ID PassValue ValParameter",
"PassValue : VALA",
"PassValue : VALB",
"PassValue : VALI",
"PassValue : VALX VLENGTH",
"PassValue : VALOID",
"PassValue : VALR",
"PassValue : VALT",
"PassValue : PassString",
"AnyType : ANY",
"AnyType : ANY DEFINED BY NAME",
"PassOid : VALOID",
"PassOid : empty",
"PassAny : VALA",
"PassAny : empty",
"PassBool : VALB",
"PassBool : empty",
"PassInt : VALI",
"PassInt : empty",
"PassBit : VALX VLENGTH",
"PassBit : VALT",
"PassBit : NullPass",
"PassString : VALS",
"PassString : VALO VLENGTH",
"PassString : VALQ",
"PassString : NullPass",
"PassReal : VALR",
"PassReal : empty",
"NullPass : empty",
"CodingFn : fnlist",
"CodingFn :",
"fn : ENC_FN",
"fn : DEC_FN",
"fn : PRT_FN",
"fn : FRE_FN",
"fnlist : fn",
"fnlist : fnlist fn",
"ValParameter : VALP",
"ValParameter : empty",
"NamedNumberList : NamedNumber",
"NamedNumberList : NamedNumberList COMMA NamedNumber",
"NamedNumber : NAME LPAREN NumericValue RPAREN",
"NumericValue : LITNUMBER",
"NumericValue : DefinedValue",
"ElementTypes : OptionalTypeList",
"ElementTypes : empty",
"MemberTypes : OptionalTypeList",
"MemberTypes : empty",
"OptionalTypeList : OptionalType",
"OptionalTypeList : OptionalTypeList COMMA UAction OptionalType",
"OptionalType : NamedType",
"OptionalType : NamedType OPTIONAL Control",
"OptionalType : NamedType OPTIONAL CAction",
"OptionalType : NamedType DEFAULT Value Control",
"OptionalType : ComponentsOf",
"OptionalType : NAME ComponentsOf",
"NamedType : NAME Type",
"NamedType : Type",
"ComponentsOf : Components Type",
"AlternativeTypeList : NamedType",
"AlternativeTypeList : AlternativeTypeList COMMA UAction NamedType",
"Tag : LBRACKET Class NumericValue RBRACKET",
"Class : UNIVERSAL",
"Class : APPLICATION",
"Class : PRIVATE",
"Class : empty",
"Valueassignment : NAME Type CCE Value",
"Value : BuiltinValue",
"Value : DefinedValue",
"BuiltinValue : L_TRUE",
"BuiltinValue : L_FALSE",
"BuiltinValue : LITNUMBER",
"BuiltinValue : BSTRING",
"BuiltinValue : HSTRING",
"BuiltinValue : LBRACE ID IdentifierList RBRACE",
"BuiltinValue : LITSTRING",
"BuiltinValue : NIL",
"BuiltinValue : LBRACE Values RBRACE",
"BuiltinValue : NAME Value",
"BuiltinValue : Type Value",
"BuiltinValue : RealValue",
"RealValue : NumericRealValue",
"RealValue : SpecialRealValue",
"SpecialRealValue : PLUSINFINITY",
"SpecialRealValue : MINUSINFINITY",
"NumericRealValue : LBRACE LITNUMBER COMMA LITNUMBER COMMA LITNUMBER RBRACE",
"DefinedValue : ID",
"DefinedValue : NAME",
"DefinedValue : ID DOT ID",
"IdentifierList : IdentifierList COMMA ID",
"IdentifierList : empty",
"Values : NamedValueList",
"Values : empty",
"NamedValueList : NamedValue",
"NamedValueList : NamedValueList COMMA NamedValue",
"NamedValue : Value",
"empty :",
"Octetstring : OCTET STRING",
"Octetstring : OCTETSTRING",
"Bitstring : BITSTRING",
"Bitstring : BIT STRING",
"SequenceOf : SEQUENCEOF",
"SequenceOf : SEQUENCE OF",
"SetOf : SETOF",
"SetOf : SET OF",
"Components : COMPONENTSOF",
"Components : COMPONENTS OF",
"ObjectIdentifierValue : LBRACE ObjIdComponentList RBRACE",
"ObjIdComponentList : ObjIdComponent",
"ObjIdComponentList : ObjIdComponentList ObjIdComponent",
"ObjIdComponent : NumberForm",
"ObjIdComponent : NameAndNumberForm",
"NumberForm : LITNUMBER",
"NumberForm : DefinedValue",
"NameAndNumberForm : NAME LPAREN NumberForm RPAREN",
"SubType : Type SubtypeSpec",
"SubType : SET SizeConstraint OF Sctrl UAction Control Type",
"SubType : SEQUENCE SizeConstraint OF Sctrl UAction Control Type",
"SubtypeSpec : LPAREN SubtypeAlternative SubtypeAlternativeList RPAREN",
"SubtypeAlternative : SubtypeValueSet",
"SubtypeAlternative : SubtypeConstraint",
"SubtypeAlternativeList : BAR SubtypeAlternative SubtypeAlternativeList",
"SubtypeAlternativeList : empty",
"SubtypeValueSet : Value",
"SubtypeValueSet : ContainedSubType",
"SubtypeValueSet : ValueRange",
"SubtypeValueSet : PermittedAlphabet",
"SubtypeConstraint : SizeConstraint",
"SubtypeConstraint : InnerTypeConstraint",
"ContainedSubType : INCLUDES Type",
"ValueRange : LowerEndPoint DOTDOT UpperEndpoint",
"LowerEndPoint : LowerEndValue",
"LowerEndPoint : LowerEndValue LANGLE",
"UpperEndpoint : UpperEndValue",
"UpperEndpoint : LANGLE UpperEndValue",
"LowerEndValue : Value",
"LowerEndValue : MIN",
"UpperEndValue : Value",
"UpperEndValue : MAX",
"SizeConstraint : SIZE SubtypeSpec",
"PermittedAlphabet : FROM SubtypeSpec",
"InnerTypeConstraint : WITH COMPONENT SingleTypeConstraint",
"InnerTypeConstraint : WITH COMPONENTS MultipleTypeConstraints",
"SingleTypeConstraint : SubtypeSpec",
"MultipleTypeConstraints : FullSpecification",
"MultipleTypeConstraints : PartialSpecification",
"FullSpecification : LBRACE TypeConstraints RBRACE",
"PartialSpecification : LBRACE DOTDOTDOT COMMA TypeConstraints RBRACE",
"TypeConstraints : NamedConstraint",
"TypeConstraints : NamedConstraint COMMA TypeConstraints",
"NamedConstraint : NAME Constraint",
"NamedConstraint : Constraint",
"Constraint : ValueConstraint",
"Constraint : PresenceConstraint",
"Constraint : empty",
"ValueConstraint : SubtypeSpec",
"PresenceConstraint : PRESENT",
"PresenceConstraint : ABSENT",
"Sctrl : SCTRL",
"Sctrl : empty",
};
#endif
#define yyclearin (yychar=(-1))
#define yyerrok (yyerrflag=0)
#ifdef YYSTACKSIZE
#ifndef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#endif
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH 500
#endif
#endif
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short yyss[YYSTACKSIZE];
YYSTYPE yyvs[YYSTACKSIZE];
#define yystacksize YYSTACKSIZE
#line 1358 "pepsy-yacc.y"

#ifdef	HPUX
#define	uchar	Uchar
#endif
#include "lex.c"
#line 1720 "y.tab.c"
#define YYABORT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
int
yyparse()
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register char *yys;
    extern char *getenv();

    if (yys = getenv("YYDEBUG"))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if (yyn = yydefred[yystate]) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("yydebug: state %d, reading %d (%s)\n", yystate,
                    yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("yydebug: state %d, shifting to state %d\n",
                    yystate, yytable[yyn]);
#endif
        if (yyssp >= yyss + yystacksize - 1)
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#ifdef lint
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#ifdef lint
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("yydebug: state %d, error recovery shifting\
 to state %d\n", *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yyss + yystacksize - 1)
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("yydebug: error recovery discarding state %d\n",
                            *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("yydebug: state %d, error recovery discards token %d (%s)\n",
                    yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("yydebug: state %d, reducing by rule %d (%s)\n",
                yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 1:
#line 354 "pepsy-yacc.y"
{
    				    mymodule = yyvsp[-3].yy_string;
				    mymoduleid = modid;
				    pass1 ();
				}
break;
case 2:
#line 359 "pepsy-yacc.y"
{ start_actions++; }
break;
case 3:
#line 361 "pepsy-yacc.y"
{ pass2 (); final_actions++; }
break;
case 4:
#line 364 "pepsy-yacc.y"
{ 
			    tagdefault = 0;
			    tagcontrol = TAG_EXPLICIT;
			}
break;
case 5:
#line 368 "pepsy-yacc.y"
{
			    tagdefault = YP_IMPLICIT;
			    tagcontrol = TAG_IMPLICIT;
			}
break;
case 6:
#line 372 "pepsy-yacc.y"
{
			    tagdefault = 0;
			    tagcontrol = TAG_UNKNOWN;
			}
break;
case 7:
#line 378 "pepsy-yacc.y"
{ yyval.yy_string = yyvsp[-1].yy_string; }
break;
case 8:
#line 381 "pepsy-yacc.y"
{ modid = yyvsp[0].yy_oid; }
break;
case 10:
#line 385 "pepsy-yacc.y"
{
				{ Action a;

				  a = new_action_t(yyvsp[0].yy_action -> ya_text,
						   yyvsp[0].yy_action -> ya_lineno,
						   0);
				    if (start_actions)
					final_action = 	a;
				    else
					start_action = a;
				    free_action (yyvsp[0].yy_action);
				    break;
				    /*NOTREACHED*/
				}
			/*
			    if (!dflag) {
				if (Cflag > 0) {
				    if (!Pflag && *sysin)
					(void) printf ("# line %d \"%s\"\n",
						$1 -> ya_lineno, sysin);
				    fputs ($1 -> ya_text, stdout);
				}
				else {
				    (void) printf ("%%{\n#include \"%s-types.h\"\n",
					    mymodule);
				    (void) printf ("%s%%}\n", $1 -> ya_text);
				    Cflag = -1;
				}
			    }
			    free_action ($1);
		    */
			}
break;
case 12:
#line 421 "pepsy-yacc.y"
{
			    yyencdflt = yyvsp[-2].yy_string;
			    yydecdflt = yyvsp[-1].yy_string;
			    yyprfdflt = yyvsp[0].yy_string;
			}
break;
case 15:
#line 431 "pepsy-yacc.y"
{ listtype = TBL_EXPORT; doexternals = 0;
				   yyporting = 1; }
break;
case 16:
#line 433 "pepsy-yacc.y"
{
			    yyporting = 0;
			}
break;
case 20:
#line 443 "pepsy-yacc.y"
{ listtype = TBL_IMPORT; yyporting = 1; }
break;
case 21:
#line 444 "pepsy-yacc.y"
{
			    yyporting = 0;
			}
break;
case 27:
#line 460 "pepsy-yacc.y"
{
				    addtableref (yyvsp[0].yy_string, modid, listtype);
				}
break;
case 28:
#line 465 "pepsy-yacc.y"
{
			    addtable(yyvsp[0].yy_string, listtype, ER_UNKNOWN);
			}
break;
case 29:
#line 468 "pepsy-yacc.y"
{ addtable (yyvsp[0].yy_string, listtype, ER_UNKNOWN); }
break;
case 30:
#line 470 "pepsy-yacc.y"
{
			    addtable(yyvsp[0].yy_string, listtype, ER_NORMAL);
			}
break;
case 31:
#line 473 "pepsy-yacc.y"
{ addtable (yyvsp[0].yy_string, listtype, ER_NORMAL); }
break;
case 32:
#line 475 "pepsy-yacc.y"
{
			    addtable(yyvsp[0].yy_string, listtype, ER_EXPLICIT);
			}
break;
case 33:
#line 478 "pepsy-yacc.y"
{ addtable (yyvsp[0].yy_string, listtype, ER_EXPLICIT); }
break;
case 38:
#line 490 "pepsy-yacc.y"
{ yysection = YP_ENCODER; yyencpref = yyvsp[0].yy_string;
			  yyprint (NULLCP, 0, 1); }
break;
case 39:
#line 493 "pepsy-yacc.y"
{ yysection = YP_DECODER; yydecpref = yyvsp[0].yy_string;
			  yyprint (NULLCP, 0, 1); }
break;
case 40:
#line 496 "pepsy-yacc.y"
{ yysection = YP_PRINTER; yyprfpref = yyvsp[0].yy_string;
			  yyprint (NULLCP, 0, 1); }
break;
case 41:
#line 499 "pepsy-yacc.y"
{
			    yysection = NULL;
			    if (strcmp (yyencpref = yyvsp[-2].yy_string, "none"))
				yysection |= YP_ENCODER;
			    if (strcmp (yydecpref = yyvsp[-1].yy_string, "none"))
				yysection |= YP_DECODER;
			    if (strcmp (yyprfpref = yyvsp[0].yy_string, "none"))
				yysection |= YP_PRINTER;
			    yyprint (NULLCP, 0, 1); 
			}
break;
case 43:
#line 512 "pepsy-yacc.y"
{ yyval.yy_string = yyvsp[0].yy_string; }
break;
case 44:
#line 513 "pepsy-yacc.y"
{ yyval.yy_string = yyvsp[0].yy_string; }
break;
case 47:
#line 521 "pepsy-yacc.y"
{
			    if (yyvsp[-1].yy_yal == NULLYAL)
				yyval.yy_yal = new_yal();
			    else
				yyval.yy_yal = yyvsp[-1].yy_yal;
			    if (yyval.yy_yal->yal_enc)
				yyerror("multiple encoding actions at the one place\n");
			    yyval.yy_yal->yal_enc = new_action_t(yyvsp[0].yy_action->ya_text,
				yyvsp[0].yy_action->ya_lineno, e_actions++);
			}
break;
case 48:
#line 531 "pepsy-yacc.y"
{
			    if (yyvsp[-1].yy_yal == NULLYAL)
				yyval.yy_yal = new_yal();
			    else
				yyval.yy_yal = yyvsp[-1].yy_yal;
			    if (yyval.yy_yal->yal_dec)
				yyerror("multiple decoding actions at the one place\n");
			    yyval.yy_yal->yal_dec = new_action_t(yyvsp[0].yy_action->ya_text, yyvsp[0].yy_action->ya_lineno, d_actions++);
			}
break;
case 49:
#line 540 "pepsy-yacc.y"
{
			    if (yyvsp[-1].yy_yal == NULLYAL)
				yyval.yy_yal = new_yal();
			    else
				yyval.yy_yal = yyvsp[-1].yy_yal;
			    if (yyval.yy_yal->yal_prn)
				yyerror("multiple printing actions at the one place\n");
			    yyval.yy_yal->yal_prn = new_action_t(yyvsp[0].yy_action->ya_text, yyvsp[0].yy_action->ya_lineno, p_actions++);
			}
break;
case 50:
#line 550 "pepsy-yacc.y"
{ yyval.yy_yal = NULLYAL; }
break;
case 51:
#line 553 "pepsy-yacc.y"
{
			    if (yyvsp[-1].yy_yal == NULLYAL)
				yyval.yy_yal = new_yal();
			    else
				yyval.yy_yal = yyvsp[-1].yy_yal;
			    if (yyval.yy_yal->yal_enc)
				yyerror("multiple choice encoding actions at the one place\n");
			    yyval.yy_yal->yal_enc = new_action_t(yyvsp[0].yy_action->ya_text,
				yyvsp[0].yy_action->ya_lineno, e_actions++);
			}
break;
case 52:
#line 563 "pepsy-yacc.y"
{
			    if (yyvsp[-1].yy_yal == NULLYAL)
				yyval.yy_yal = new_yal();
			    else
				yyval.yy_yal = yyvsp[-1].yy_yal;
			    if (yyval.yy_yal->yal_dec)
				yyerror("multiple choice decoding actions at the one place\n");
			    yyval.yy_yal->yal_dec = new_action_t(yyvsp[0].yy_action->ya_text, yyvsp[0].yy_action->ya_lineno, d_actions ++);
			}
break;
case 53:
#line 572 "pepsy-yacc.y"
{
			    if (yyvsp[-1].yy_yal == NULLYAL)
				yyval.yy_yal = new_yal();
			    else
				yyval.yy_yal = yyvsp[-1].yy_yal;
			    if (yyval.yy_yal->yal_prn)
				yyerror("multiple choice printing actions at the one place\n");
			    yyval.yy_yal->yal_prn = new_action_t(yyvsp[0].yy_action->ya_text, yyvsp[0].yy_action->ya_lineno, 0);
			}
break;
case 54:
#line 582 "pepsy-yacc.y"
{ yyval.yy_yal = NULLYAL; }
break;
case 55:
#line 586 "pepsy-yacc.y"
{
			    if (yyvsp[-3].yy_string)
			        yyvsp[0].yy_type -> yp_param_type = yyvsp[-3].yy_string;
			    if (yyvsp[-1].yy_yal)
				yyvsp[0].yy_type->yp_bef_alist=yal_join(yyvsp[-1].yy_yal, yyvsp[0].yy_type->yp_bef_alist);
			    pass1_type (yyencpref, yydecpref, yyprfpref,
				    mymodule, yyvsp[-4].yy_string, yyvsp[0].yy_type);
			}
break;
case 56:
#line 595 "pepsy-yacc.y"
{
			    yyval.yy_type = yyvsp[-2].yy_type;
			    yyval.yy_type -> yp_direction = yysection;
			    if (yyvsp[-1].yy_yfn)
				yyval.yy_type->yp_yfn = join_yfn(yyval.yy_type->yp_yfn, yyvsp[-1].yy_yfn);
			    if (yyvsp[0].yy_yal)
				yyval.yy_type->yp_aft_alist=yal_join(yyvsp[0].yy_yal, yyval.yy_type->yp_aft_alist);
			}
break;
case 57:
#line 603 "pepsy-yacc.y"
{
			    yyval.yy_type = yyvsp[-2].yy_type;
			    yyval.yy_type -> yp_direction = yysection;
			    if (yyvsp[-1].yy_yfn)
				yyval.yy_type->yp_yfn = join_yfn(yyval.yy_type->yp_yfn, yyvsp[-1].yy_yfn);
			    if (yyvsp[0].yy_yal)
				yyval.yy_type->yp_aft_alist=yal_join(yyvsp[0].yy_yal, yyval.yy_type->yp_aft_alist);
			}
break;
case 58:
#line 611 "pepsy-yacc.y"
{
			    yyval.yy_type = yyvsp[-2].yy_type;
			    yyval.yy_type -> yp_direction = yysection;
			    if (yyvsp[-1].yy_yfn)
				yyval.yy_type->yp_yfn = join_yfn(yyval.yy_type->yp_yfn, yyvsp[-1].yy_yfn);
			    if (yyvsp[0].yy_yal)
				yyval.yy_type->yp_aft_alist=yal_join(yyvsp[0].yy_yal, yyval.yy_type->yp_aft_alist);
			}
break;
case 60:
#line 623 "pepsy-yacc.y"
{ yyval.yy_string = NULLCP; }
break;
case 62:
#line 627 "pepsy-yacc.y"
{ yyval.yy_string = NULLCP; }
break;
case 63:
#line 630 "pepsy-yacc.y"
{
			    yyval.yy_type = new_type(YP_UNDF, -1);
			    if (setvaltype(yyval.yy_type, yyvsp[0].yy_string) == 0)
				yyerror("syntax error in [[ T ... ]]");
			    free(yyvsp[0].yy_string);
			}
break;
case 64:
#line 636 "pepsy-yacc.y"
{ yyval.yy_type = new_type(YP_UNDF, -1); }
break;
case 65:
#line 639 "pepsy-yacc.y"
{
			    yyval.yy_type = new_type (YP_BOOL, yyvsp[-1].yy_number);
			    yyval.yy_type -> yp_intexp = yyvsp[0].yy_string;
			}
break;
case 66:
#line 643 "pepsy-yacc.y"
{
			    yyval.yy_type = new_type (yyvsp[0].yy_value ? YP_INTLIST : YP_INT, yyvsp[-2].yy_number);
			    yyval.yy_type -> yp_intexp = yyvsp[-1].yy_string;
			    if (yyvsp[0].yy_value)
				    yyval.yy_type -> yp_value = yyvsp[0].yy_value;
	    		}
break;
case 67:
#line 650 "pepsy-yacc.y"
{
			    yyval.yy_type = new_type (YP_ENUMLIST, yyvsp[-4].yy_number);
			    yyval.yy_type -> yp_intexp = yyvsp[-3].yy_string;
			    yyval.yy_type -> yp_value = yyvsp[-1].yy_value;
			}
break;
case 68:
#line 656 "pepsy-yacc.y"
{
			    yyval.yy_type = yyvsp[-1].yy_type;
	    		    yyval.yy_type -> yp_code = yyvsp[0].yy_value ? YP_BITLIST: YP_BIT;
			    if (yyvsp[0].yy_value)
				yyval.yy_type -> yp_value = yyvsp[0].yy_value;
			}
break;
case 69:
#line 662 "pepsy-yacc.y"
{
			    yyval.yy_type = yyvsp[0].yy_type;
			    yyval.yy_type -> yp_code = YP_OCT;
			}
break;
case 70:
#line 666 "pepsy-yacc.y"
{
			    yyval.yy_type = new_type (YP_NULL, yyvsp[0].yy_number);
			}
break;
case 71:
#line 669 "pepsy-yacc.y"
{
			    yyval.yy_type = new_type (YP_SEQ, yyvsp[-2].yy_number);
			    yyval.yy_type -> yp_strexp = yyvsp[0].yy_string;
			}
break;
case 72:
#line 673 "pepsy-yacc.y"
{
			    yyval.yy_type = yyvsp[-3].yy_type;
			    yyval.yy_type->yp_code = YP_SEQTYPE;
			    yyval.yy_type -> yp_type = yyvsp[0].yy_type;
			    if (yyvsp[-4].yy_sctrl) {
				yyval.yy_type -> yp_structname = yyvsp[-4].yy_sctrl -> ys_structname;
				yyval.yy_type -> yp_ptrname = yyvsp[-4].yy_sctrl -> ys_ptrname;
				free_ys (yyvsp[-4].yy_sctrl);
			    }
			    if (yyvsp[-2].yy_string) {
				yyval.yy_type -> yp_control = yyvsp[-2].yy_string;
				yyval.yy_type -> yp_flags |= YP_CONTROLLED;
			    }
			    if (yyvsp[-1].yy_yal)
				yyvsp[0].yy_type->yp_bef_alist=yal_join(yyvsp[-1].yy_yal, yyvsp[0].yy_type->yp_bef_alist);
			}
break;
case 73:
#line 689 "pepsy-yacc.y"
{
			    yyval.yy_type = yyvsp[-4].yy_type;
			    yyval.yy_type->yp_code = YP_SEQLIST;
			    yyval.yy_type -> yp_type = yyvsp[-1].yy_type;
			    if (yyvsp[-5].yy_sctrl) {
                                yyval.yy_type -> yp_structname = yyvsp[-5].yy_sctrl -> ys_structname;
                                yyval.yy_type -> yp_ptrname = yyvsp[-5].yy_sctrl -> ys_ptrname;
                                free_ys (yyvsp[-5].yy_sctrl);
                            }
			    if (yyvsp[-1].yy_type && yyvsp[-2].yy_yal)
				yyvsp[-1].yy_type->yp_bef_alist=yal_join(yyvsp[-2].yy_yal, yyvsp[-1].yy_type->yp_bef_alist);
	    		}
break;
case 74:
#line 701 "pepsy-yacc.y"
{
			    yyval.yy_type = new_type (YP_SET, yyvsp[-2].yy_number);
			    yyval.yy_type -> yp_strexp = yyvsp[0].yy_string;
			}
break;
case 75:
#line 705 "pepsy-yacc.y"
{
			    yyval.yy_type = yyvsp[-3].yy_type;
			    yyval.yy_type->yp_code = YP_SETTYPE;
			    yyval.yy_type -> yp_type = yyvsp[0].yy_type;
			    if (yyvsp[-4].yy_sctrl) {
				yyval.yy_type -> yp_structname = yyvsp[-4].yy_sctrl -> ys_structname;
				yyval.yy_type -> yp_ptrname = yyvsp[-4].yy_sctrl -> ys_ptrname;
				free_ys (yyvsp[-4].yy_sctrl);
			    }
			    if (yyvsp[-2].yy_string) {
				yyval.yy_type -> yp_control = yyvsp[-2].yy_string;
				yyval.yy_type -> yp_flags |= YP_CONTROLLED;
			    }
			    if (yyvsp[-1].yy_yal)
				yyvsp[0].yy_type->yp_bef_alist=yal_join(yyvsp[-1].yy_yal, yyvsp[0].yy_type->yp_bef_alist);
			}
break;
case 76:
#line 722 "pepsy-yacc.y"
{
			    yyval.yy_type = yyvsp[-4].yy_type;
			    yyval.yy_type->yp_code = YP_SETLIST;
			    yyval.yy_type -> yp_type = yyvsp[-1].yy_type;
			    if (yyvsp[-5].yy_sctrl) {
				yyval.yy_type -> yp_structname = yyvsp[-5].yy_sctrl -> ys_structname;
				yyval.yy_type -> yp_ptrname = yyvsp[-5].yy_sctrl -> ys_ptrname;
				free_ys (yyvsp[-5].yy_sctrl);
			    }
			    if (yyvsp[-1].yy_type && yyvsp[-2].yy_yal)
				yyvsp[-1].yy_type->yp_bef_alist=yal_join(yyvsp[-2].yy_yal, yyvsp[-1].yy_type->yp_bef_alist);
	    		}
break;
case 77:
#line 734 "pepsy-yacc.y"
{
			    yyval.yy_type = yyvsp[0].yy_type;
			    yyval.yy_type -> yp_tag = yyvsp[-3].yy_tag;
			    yyval.yy_type -> yp_flags |= (YP_IMPLICIT | YP_TAG);
			    if (yyvsp[-2].yy_yal)
				yyval.yy_type->yp_bef_alist=yal_join(yyvsp[-2].yy_yal, yyval.yy_type->yp_bef_alist);
			}
break;
case 78:
#line 741 "pepsy-yacc.y"
{
			    yyval.yy_type = yyvsp[0].yy_type;
			    yyval.yy_type -> yp_tag = yyvsp[-3].yy_tag;
			    yyval.yy_type -> yp_flags |= YP_TAG;
			    if (yyvsp[-2].yy_yal)
				yyval.yy_type->yp_bef_alist=yal_join(yyvsp[-2].yy_yal, yyval.yy_type->yp_bef_alist);
			}
break;
case 79:
#line 748 "pepsy-yacc.y"
{
			    yyval.yy_type = yyvsp[0].yy_type;
			    yyval.yy_type -> yp_tag = yyvsp[-2].yy_tag;
			    yyval.yy_type -> yp_flags |= (YP_TAG| tagdefault);
			    if (yyvsp[-1].yy_yal)
				yyval.yy_type->yp_bef_alist=yal_join(yyvsp[-1].yy_yal, yyval.yy_type->yp_bef_alist);
			}
break;
case 80:
#line 756 "pepsy-yacc.y"
{
			    yyval.yy_type = yyvsp[-6].yy_type;
			    yyval.yy_type->yp_code = YP_CHOICE;
			    yyval.yy_type -> yp_type = yyvsp[-1].yy_type;
			    if (yyvsp[-7].yy_sctrl) {
				yyval.yy_type -> yp_structname = yyvsp[-7].yy_sctrl -> ys_structname;
				yyval.yy_type -> yp_ptrname = yyvsp[-7].yy_sctrl -> ys_ptrname;
				free_ys (yyvsp[-7].yy_sctrl);
			    }
			    if (yyvsp[-5].yy_string) {
				yyval.yy_type -> yp_control = yyvsp[-5].yy_string;
				yyval.yy_type -> yp_flags |= YP_CONTROLLED;
			    }
			    if (yyvsp[-4].yy_yal)
				yyval.yy_type -> yp_control_act = yyvsp[-4].yy_yal;
			    if (yyvsp[-1].yy_type && yyvsp[-2].yy_yal)
				yyvsp[-1].yy_type->yp_bef_alist=yal_join(yyvsp[-2].yy_yal, yyvsp[-1].yy_type->yp_bef_alist);
			}
break;
case 81:
#line 774 "pepsy-yacc.y"
{
			    yyval.yy_type = yyvsp[0].yy_type;
			    yyval.yy_type -> yp_bound = yyvsp[-2].yy_string;
			    yyval.yy_type -> yp_flags |= YP_BOUND;
			}
break;
case 82:
#line 779 "pepsy-yacc.y"
{
			    yyval.yy_type = new_type (YP_ANY, yyvsp[-1].yy_number);
			    yyval.yy_type -> yp_strexp = yyvsp[0].yy_string;
			}
break;
case 83:
#line 783 "pepsy-yacc.y"
{
			    yyval.yy_type = new_type (YP_ANY, yyvsp[-1].yy_number);
			    yyval.yy_type -> yp_strexp = yyvsp[0].yy_string;
			    yyval.yy_type -> yp_flags |= YP_WANTIMPLICIT;
			}
break;
case 84:
#line 788 "pepsy-yacc.y"
{
			    yyval.yy_type = new_type (YP_OID, yyvsp[-2].yy_number);
			    yyval.yy_type -> yp_strexp = yyvsp[0].yy_string;
			}
break;
case 85:
#line 792 "pepsy-yacc.y"
{
			    yyval.yy_type = yyvsp[0].yy_type;
			    yyval.yy_type -> yp_tag = new_tag (PE_CLASS_UNIV);
			    yyval.yy_type -> yp_tag -> yt_value = new_value(YV_NUMBER);
			    yyval.yy_type -> yp_tag -> yt_value -> yv_number = PE_PRIM_ENCR;
			    yyval.yy_type -> yp_flags |=
			    	(YP_ENCRYPTED | YP_TAG | YP_IMPLICIT);
			}
break;
case 86:
#line 800 "pepsy-yacc.y"
{
			    yyval.yy_type = new_type(YP_REAL, yyvsp[-1].yy_number);
			    yyval.yy_type -> yp_strexp = yyvsp[0].yy_string;
			}
break;
case 87:
#line 806 "pepsy-yacc.y"
{ yyval.yy_value = yyvsp[-1].yy_value; }
break;
case 88:
#line 807 "pepsy-yacc.y"
{	yyval.yy_value = NULL; }
break;
case 89:
#line 809 "pepsy-yacc.y"
{
			    yyval.yy_type = yyvsp[-1].yy_type;
			    yyval.yy_type -> yp_code = YP_IDEFINED;
			    yyval.yy_type -> yp_identifier = yyvsp[-2].yy_string;
			    if (yyvsp[0].yy_string) {
				yyval.yy_type -> yp_parm = yyvsp[0].yy_string;
				yyval.yy_type -> yp_flags |= YP_PARMVAL;
			    }
			    check_impexp (yyval.yy_type);
			}
break;
case 90:
#line 819 "pepsy-yacc.y"
{
			    yyval.yy_type = yyvsp[-1].yy_type;
			    yyval.yy_type -> yp_code = YP_IDEFINED;
			    yyval.yy_type -> yp_identifier = yyvsp[-2].yy_string;
			    yyval.yy_type -> yp_module = yyvsp[-4].yy_string;
			    if (yyvsp[0].yy_string) {
				yyval.yy_type -> yp_parm = yyvsp[0].yy_string;
				yyval.yy_type -> yp_flags |= YP_PARMVAL;
			    }
			}
break;
case 91:
#line 831 "pepsy-yacc.y"
{
			    yyval.yy_type = new_type (YP_UNDF, -1);
			    yyval.yy_type -> yp_intexp = NULLCP;
			    yyval.yy_type -> yp_strexp = yyvsp[0].yy_string;
			    yyval.yy_type -> yp_prfexp = 'a';
			}
break;
case 92:
#line 837 "pepsy-yacc.y"
{
			    yyval.yy_type = new_type (YP_UNDF, -1);
			    yyval.yy_type -> yp_intexp = yyvsp[0].yy_string;
			    yyval.yy_type -> yp_strexp = NULLCP;
			    yyval.yy_type -> yp_prfexp = 'b';
			}
break;
case 93:
#line 843 "pepsy-yacc.y"
{
			    yyval.yy_type = new_type (YP_UNDF, -1);
			    yyval.yy_type -> yp_intexp = yyvsp[0].yy_string;
			    yyval.yy_type -> yp_strexp = NULLCP;
			    yyval.yy_type -> yp_prfexp = 'i';
			}
break;
case 94:
#line 849 "pepsy-yacc.y"
{
			    yyval.yy_type = new_type (YP_UNDF, -1);
			    yyval.yy_type -> yp_intexp = yyvsp[0].yy_string;
			    yyval.yy_type -> yp_strexp = yyvsp[-1].yy_string;
			    yyval.yy_type -> yp_prfexp = 'x';
			}
break;
case 95:
#line 855 "pepsy-yacc.y"
{
			    yyval.yy_type = new_type (YP_UNDF, -1);
			    yyval.yy_type -> yp_intexp = NULLCP;
			    yyval.yy_type -> yp_strexp = yyvsp[0].yy_string;
			    yyval.yy_type -> yp_prfexp = 'O';
			}
break;
case 96:
#line 861 "pepsy-yacc.y"
{
			    yyval.yy_type = new_type (YP_UNDF, -1);
			    yyval.yy_type -> yp_intexp = NULLCP;
			    yyval.yy_type -> yp_strexp = yyvsp[0].yy_string;
			    yyval.yy_type -> yp_prfexp = 'r';
			}
break;
case 97:
#line 867 "pepsy-yacc.y"
{
			    yyval.yy_type = new_type (YP_UNDF, -1);
			    yyval.yy_type -> yp_intexp = yyvsp[0].yy_string;
			    yyval.yy_type -> yp_prfexp = 't';
			}
break;
case 102:
#line 880 "pepsy-yacc.y"
{ yyval.yy_string = NULLCP; }
break;
case 104:
#line 884 "pepsy-yacc.y"
{ yyval.yy_string = NULLCP; }
break;
case 106:
#line 888 "pepsy-yacc.y"
{ yyval.yy_string = NULLCP; }
break;
case 108:
#line 892 "pepsy-yacc.y"
{ yyval.yy_string = NULLCP; }
break;
case 109:
#line 895 "pepsy-yacc.y"
{
			    yyval.yy_type = new_type (YP_UNDF, -1);
			    yyval.yy_type -> yp_intexp = yyvsp[0].yy_string;
			    yyval.yy_type -> yp_strexp = yyvsp[-1].yy_string;
			}
break;
case 110:
#line 900 "pepsy-yacc.y"
{
			    yyval.yy_type = new_type (YP_UNDF, -1);
			    yyval.yy_type -> yp_intexp = yyvsp[0].yy_string;
			    yyval.yy_type -> yp_strexp = NULLCP;
			}
break;
case 112:
#line 908 "pepsy-yacc.y"
{
			    yyval.yy_type = new_type (YP_UNDF, -1);
			    yyval.yy_type -> yp_intexp = NULLCP;
			    yyval.yy_type -> yp_strexp = yyvsp[0].yy_string;
			    yyval.yy_type -> yp_prfexp = 's';
			}
break;
case 113:
#line 914 "pepsy-yacc.y"
{
			    yyval.yy_type = new_type (YP_UNDF, -1);
			    yyval.yy_type -> yp_intexp = yyvsp[0].yy_string;
			    yyval.yy_type -> yp_strexp = yyvsp[-1].yy_string;
			    yyval.yy_type -> yp_prfexp = 'o';
			}
break;
case 114:
#line 920 "pepsy-yacc.y"
{
			    yyval.yy_type = new_type (YP_UNDF, -1);
			    yyval.yy_type -> yp_intexp = NULLCP;
			    yyval.yy_type -> yp_strexp = yyvsp[0].yy_string;
			    yyval.yy_type -> yp_prfexp = 'q';
			}
break;
case 117:
#line 930 "pepsy-yacc.y"
{ yyval.yy_string = NULLCP; }
break;
case 118:
#line 933 "pepsy-yacc.y"
{
			    yyval.yy_type = new_type (YP_UNDF, -1);
			    yyval.yy_type -> yp_intexp = NULLCP;
			    yyval.yy_type -> yp_strexp = NULLCP;
			}
break;
case 119:
#line 940 "pepsy-yacc.y"
{
			    yyval.yy_yfn = new_yfn(efn, dfn, pfn, ffn);
			    clrfn();
			}
break;
case 120:
#line 944 "pepsy-yacc.y"
{ yyval.yy_yfn = NULLYFN; }
break;
case 121:
#line 947 "pepsy-yacc.y"
{
		    if (efn)
			myyerror("extra encoding function %s ignored\n", yyvsp[0].yy_string);
		    else
			efn = yyvsp[0].yy_string;
		}
break;
case 122:
#line 953 "pepsy-yacc.y"
{
		    if (dfn)
			myyerror("extra decoding function %s ignored\n", yyvsp[0].yy_string);
		    else
			dfn = yyvsp[0].yy_string;
		}
break;
case 123:
#line 959 "pepsy-yacc.y"
{
		    if (pfn)
			myyerror("extra printing function %s ignored\n", yyvsp[0].yy_string);
		    else
			pfn = yyvsp[0].yy_string;
		}
break;
case 124:
#line 965 "pepsy-yacc.y"
{
		    if (ffn)
			myyerror("extra freeing function %s ignored\n", yyvsp[0].yy_string);
		    else
			ffn = yyvsp[0].yy_string;
		}
break;
case 128:
#line 977 "pepsy-yacc.y"
{ yyval.yy_string = NULLCP; }
break;
case 129:
#line 980 "pepsy-yacc.y"
{ yyval.yy_value = yyvsp[0].yy_value; }
break;
case 130:
#line 981 "pepsy-yacc.y"
{
			    yyval.yy_value = add_value (yyvsp[-2].yy_value, yyvsp[0].yy_value);
			}
break;
case 131:
#line 985 "pepsy-yacc.y"
{
			    yyval.yy_value = yyvsp[-1].yy_value;
			    yyval.yy_value -> yv_named = yyvsp[-3].yy_string;
			    yyval.yy_value -> yv_flags |= YV_NAMED;
			}
break;
case 132:
#line 991 "pepsy-yacc.y"
{
			    yyval.yy_value = new_value (YV_NUMBER);
			    yyval.yy_value -> yv_number = yyvsp[0].yy_number;
			}
break;
case 134:
#line 998 "pepsy-yacc.y"
{ yyval.yy_type = yyvsp[0].yy_type; }
break;
case 135:
#line 999 "pepsy-yacc.y"
{ yyval.yy_type = NULLYP; }
break;
case 136:
#line 1001 "pepsy-yacc.y"
{ yyval.yy_type = yyvsp[0].yy_type; }
break;
case 137:
#line 1003 "pepsy-yacc.y"
{ yyval.yy_type = NULLYP; }
break;
case 138:
#line 1005 "pepsy-yacc.y"
{ yyval.yy_type = yyvsp[0].yy_type; }
break;
case 139:
#line 1006 "pepsy-yacc.y"
{
			    if (yyvsp[-1].yy_yal)
				yyvsp[0].yy_type->yp_bef_alist=yal_join(yyvsp[-1].yy_yal, yyvsp[0].yy_type->yp_bef_alist);
			    yyval.yy_type = add_type (yyvsp[-3].yy_type, yyvsp[0].yy_type);
			}
break;
case 140:
#line 1012 "pepsy-yacc.y"
{ yyval.yy_type = yyvsp[0].yy_type; }
break;
case 141:
#line 1013 "pepsy-yacc.y"
{
			    yyval.yy_type = yyvsp[-2].yy_type;
			    yyval.yy_type -> yp_flags |= YP_OPTIONAL;
			    if (yyvsp[0].yy_string) {
				yyval.yy_type -> yp_optcontrol = yyvsp[0].yy_string;
				yyval.yy_type -> yp_flags |= YP_OPTCONTROL;
			    }
			}
break;
case 142:
#line 1021 "pepsy-yacc.y"
{
			    yyval.yy_type = yyvsp[-2].yy_type;
			    yyval.yy_type -> yp_flags |= YP_OPTIONAL;
			    if (yyvsp[0].yy_yal) {
				yyval.yy_type -> yp_flags |= YP_OPTCONTROL;
				yyval.yy_type -> yp_optional_act = yyvsp[0].yy_yal;
			    }
			}
break;
case 143:
#line 1029 "pepsy-yacc.y"
{
			    yyval.yy_type = yyvsp[-3].yy_type;
			    yyval.yy_type -> yp_default = yyvsp[-1].yy_value;
			    yyval.yy_type -> yp_flags |= YP_DEFAULT;
			    if (yyvsp[0].yy_string) {
				yyval.yy_type -> yp_optcontrol = yyvsp[0].yy_string;
				yyval.yy_type -> yp_flags |= YP_OPTCONTROL;
			    }
			}
break;
case 144:
#line 1038 "pepsy-yacc.y"
{ yyval.yy_type = yyvsp[0].yy_type; }
break;
case 145:
#line 1039 "pepsy-yacc.y"
{ yyval.yy_type = yyvsp[0].yy_type; yyval.yy_type->yp_id = yyvsp[-1].yy_string; }
break;
case 146:
#line 1041 "pepsy-yacc.y"
{
			    yyval.yy_type = yyvsp[0].yy_type;
			    yyval.yy_type -> yp_id = yyvsp[-1].yy_string;
			    yyval.yy_type -> yp_flags |= YP_ID;
			}
break;
case 147:
#line 1046 "pepsy-yacc.y"
{ yyval.yy_type = yyvsp[0].yy_type; }
break;
case 148:
#line 1048 "pepsy-yacc.y"
{
			    yyval.yy_type = yyvsp[0].yy_type;
			    yyval.yy_type -> yp_flags |= YP_COMPONENTS;
			}
break;
case 149:
#line 1053 "pepsy-yacc.y"
{ yyval.yy_type = yyvsp[0].yy_type; }
break;
case 150:
#line 1054 "pepsy-yacc.y"
{
			    if (yyvsp[-1].yy_yal)
				yyvsp[0].yy_type->yp_bef_alist=yal_join(yyvsp[-1].yy_yal, yyvsp[0].yy_type->yp_bef_alist);
			    yyval.yy_type = add_type (yyvsp[-3].yy_type, yyvsp[0].yy_type);
			}
break;
case 151:
#line 1061 "pepsy-yacc.y"
{
			    yyval.yy_tag = yyvsp[-2].yy_tag;
			    yyval.yy_tag -> yt_value = yyvsp[-1].yy_value;
			}
break;
case 152:
#line 1066 "pepsy-yacc.y"
{ yyval.yy_tag = new_tag (PE_CLASS_UNIV); }
break;
case 153:
#line 1067 "pepsy-yacc.y"
{ yyval.yy_tag = new_tag (PE_CLASS_APPL); }
break;
case 154:
#line 1068 "pepsy-yacc.y"
{ yyval.yy_tag = new_tag (PE_CLASS_PRIV); }
break;
case 155:
#line 1069 "pepsy-yacc.y"
{ yyval.yy_tag = new_tag (PE_CLASS_CONT); }
break;
case 159:
#line 1079 "pepsy-yacc.y"
{
			    yyval.yy_value = new_value (YV_BOOL);
			    yyval.yy_value -> yv_number = 1;
			}
break;
case 160:
#line 1083 "pepsy-yacc.y"
{
			    yyval.yy_value = new_value (YV_BOOL);
			    yyval.yy_value -> yv_number = 0;
			}
break;
case 161:
#line 1087 "pepsy-yacc.y"
{
			    yyval.yy_value = new_value (YV_NUMBER);
			    yyval.yy_value -> yv_number = yyvsp[0].yy_number;
			}
break;
case 162:
#line 1091 "pepsy-yacc.y"
{
			    yyval.yy_value = new_value (YV_BSTRING);
			    yyval.yy_value -> yv_xstring = bit2bin(yyvsp[0].yy_string, &yyval.yy_value->yv_xlength);
			    free(yyvsp[0].yy_string);
			}
break;
case 163:
#line 1096 "pepsy-yacc.y"
{
			    yyval.yy_value = new_value (YV_HSTRING);
			    yyval.yy_value -> yv_xstring = hex2bin(yyvsp[0].yy_string, &yyval.yy_value->yv_xlength);
			    free(yyvsp[0].yy_string);
			}
break;
case 164:
#line 1101 "pepsy-yacc.y"
{
			    yyval.yy_value = new_value (YV_IDLIST);
			    yyval.yy_value -> yv_idlist = new_value (YV_IDEFINED);
			    yyval.yy_value -> yv_idlist -> yv_identifier = yyvsp[-2].yy_string;
			    if (yyvsp[-1].yy_value)
			        yyval.yy_value = add_value (yyval.yy_value, yyvsp[-1].yy_value);
			}
break;
case 165:
#line 1108 "pepsy-yacc.y"
{
			    yyval.yy_value = new_value (YV_STRING);
			    yyval.yy_value -> yv_string = yyvsp[0].yy_string;
			}
break;
case 166:
#line 1112 "pepsy-yacc.y"
{ yyval.yy_value = new_value (YV_NULL); }
break;
case 167:
#line 1113 "pepsy-yacc.y"
{
			    yyval.yy_value = new_value (YV_VALIST);
			    yyval.yy_value -> yv_idlist = yyvsp[-1].yy_value;
			}
break;
case 168:
#line 1117 "pepsy-yacc.y"
{
			    yyval.yy_value = yyvsp[0].yy_value;
			    yyval.yy_value -> yv_id = yyvsp[-1].yy_string;
			    yyval.yy_value -> yv_flags |= YV_ID;
			}
break;
case 169:
#line 1122 "pepsy-yacc.y"
{
			    yyval.yy_value = yyvsp[0].yy_value;
			    yyval.yy_value -> yv_type = yyvsp[-1].yy_type;
			    yyval.yy_value -> yv_flags |= YV_TYPE;
			}
break;
case 170:
#line 1127 "pepsy-yacc.y"
{
			    yyval.yy_value = new_value (YV_REAL);
			    yyval.yy_value -> yv_real = yyvsp[0].yy_real;
			}
break;
case 173:
#line 1137 "pepsy-yacc.y"
{ yyval.yy_real = PE_REAL_INFINITY;}
break;
case 174:
#line 1138 "pepsy-yacc.y"
{ yyval.yy_real = - PE_REAL_INFINITY; }
break;
case 175:
#line 1142 "pepsy-yacc.y"
{
				if (yyvsp[-3].yy_number != 2 && yyvsp[-3].yy_number != 10)
					myyerror ("Illegal base value %d", yyvsp[-3].yy_number);
				yyval.yy_real = yyvsp[-5].yy_number * pow ((double)yyvsp[-3].yy_number, (double)yyvsp[-1].yy_number);
			}
break;
case 176:
#line 1149 "pepsy-yacc.y"
{
			    yyval.yy_value = new_value (YV_IDEFINED);
			    yyval.yy_value -> yv_identifier = yyvsp[0].yy_string;
			}
break;
case 177:
#line 1153 "pepsy-yacc.y"
{	/* XXX */
			    yyval.yy_value = new_value (YV_IDEFINED);
			    yyval.yy_value -> yv_identifier = yyvsp[0].yy_string;
			    yyval.yy_value -> yv_flags |= YV_BOUND;
			}
break;
case 178:
#line 1158 "pepsy-yacc.y"
{
			    yyval.yy_value = new_value (YV_IDEFINED);
			    yyval.yy_value -> yv_identifier = yyvsp[0].yy_string;
			    yyval.yy_value -> yv_module = yyvsp[-2].yy_string;
			}
break;
case 179:
#line 1165 "pepsy-yacc.y"
{
			    yyval.yy_value = new_value (YV_IDEFINED);
			    yyval.yy_value -> yv_identifier = yyvsp[0].yy_string;
			    if (yyvsp[-2].yy_value)
			        yyval.yy_value = add_value (yyvsp[-2].yy_value, yyval.yy_value);
			}
break;
case 180:
#line 1171 "pepsy-yacc.y"
{ yyval.yy_value = NULLYV; }
break;
case 181:
#line 1174 "pepsy-yacc.y"
{ yyval.yy_value = yyvsp[0].yy_value; }
break;
case 182:
#line 1175 "pepsy-yacc.y"
{ yyval.yy_value = NULLYV; }
break;
case 183:
#line 1177 "pepsy-yacc.y"
{ yyval.yy_value = yyvsp[0].yy_value; }
break;
case 184:
#line 1178 "pepsy-yacc.y"
{
			    yyval.yy_value = add_value (yyvsp[-2].yy_value, yyvsp[0].yy_value);
			}
break;
case 185:
#line 1182 "pepsy-yacc.y"
{ yyval.yy_value = yyvsp[0].yy_value; }
break;
case 197:
#line 1206 "pepsy-yacc.y"
{ yyval.yy_oid = yyvsp[-1].yy_oid; }
break;
case 199:
#line 1211 "pepsy-yacc.y"
{
				yyval.yy_oid = addoid(yyvsp[-1].yy_oid, yyvsp[0].yy_oid);
				oid_free (yyvsp[-1].yy_oid);
				oid_free (yyvsp[0].yy_oid);
			}
break;
case 202:
#line 1222 "pepsy-yacc.y"
{ yyval.yy_oid = int2oid (yyvsp[0].yy_number); }
break;
case 203:
#line 1223 "pepsy-yacc.y"
{
				yyval.yy_oid = oidlookup(yyvsp[0].yy_value->yv_identifier);
				free((char *)yyvsp[0].yy_value);
			}
break;
case 204:
#line 1229 "pepsy-yacc.y"
{
				free (yyvsp[-3].yy_string);
				yyval.yy_oid = yyvsp[-1].yy_oid;
			}
break;
case 206:
#line 1236 "pepsy-yacc.y"
{
			    yyval.yy_type = new_type (YP_SETTYPE, yyvsp[-6].yy_number);
			    yyval.yy_type -> yp_type = yyvsp[0].yy_type;
			    if (yyvsp[-3].yy_sctrl) {
				yyval.yy_type -> yp_structname = yyvsp[-3].yy_sctrl -> ys_structname;
				yyval.yy_type -> yp_ptrname = yyvsp[-3].yy_sctrl -> ys_ptrname;
				free_ys (yyvsp[-3].yy_sctrl);
			    }
			    if (yyvsp[-1].yy_string) {
			    	yyval.yy_type -> yp_control = yyvsp[-1].yy_string;
				yyval.yy_type -> yp_flags |= YP_CONTROLLED;
			    }
			    if (yyvsp[-2].yy_yal)
				yyvsp[0].yy_type->yp_bef_alist=yal_join(yyvsp[-2].yy_yal, yyvsp[0].yy_type->yp_bef_alist);
	    		}
break;
case 207:
#line 1252 "pepsy-yacc.y"
{
			    yyval.yy_type = new_type (YP_SEQTYPE, yyvsp[-6].yy_number);
			    yyval.yy_type -> yp_type = yyvsp[0].yy_type;
			    if (yyvsp[-3].yy_sctrl) {
				yyval.yy_type -> yp_structname = yyvsp[-3].yy_sctrl -> ys_structname;
				yyval.yy_type -> yp_ptrname = yyvsp[-3].yy_sctrl -> ys_ptrname;
				free_ys (yyvsp[-3].yy_sctrl);
			    }
			    if (yyvsp[-1].yy_string) {
				yyval.yy_type -> yp_control = yyvsp[-1].yy_string;
				yyval.yy_type -> yp_flags |= YP_CONTROLLED;
			    }
			    if (yyvsp[-2].yy_yal)
				yyvsp[0].yy_type->yp_bef_alist=yal_join(yyvsp[-2].yy_yal, yyvsp[0].yy_type->yp_bef_alist);
			}
break;
case 248:
#line 1354 "pepsy-yacc.y"
{ yyval.yy_sctrl = new_ys (yyvsp[0].yy_string); }
break;
case 249:
#line 1355 "pepsy-yacc.y"
{ yyval.yy_sctrl = NULLYS; }
break;
#line 3022 "y.tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("yydebug: after reduction, shifting from state 0 to\
 state %d\n", YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("yydebug: state %d, reading %d (%s)\n",
                        YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("yydebug: after reduction, shifting from state %d \
to state %d\n", *yyssp, yystate);
#endif
    if (yyssp >= yyss + yystacksize - 1)
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
